"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/ChatList/ChatList.tsx
var ChatList_exports = {};
__export(ChatList_exports, {
  default: () => ChatList_default
});
module.exports = __toCommonJS(ChatList_exports);
var import_classnames3 = __toESM(require("classnames"));

// src/ChatItem/ChatItem.tsx
var import_react2 = require("react");

// src/Avatar/Avatar.tsx
var import_react = require("react");
var import_classnames = __toESM(require("classnames"));
var import_jsx_runtime = require("react/jsx-runtime");
var Avatar = (_a) => {
  var _b = _a, {
    type = "default",
    size = "default",
    lazyLoadingImage = void 0
  } = _b, props = __objRest(_b, [
    "type",
    "size",
    "lazyLoadingImage"
  ]);
  const loadedAvatars = [];
  let loading = false;
  let src = props.src;
  let isLazyImage = false;
  (0, import_react.useEffect)(() => {
    if (lazyLoadingImage) {
      isLazyImage = true;
      if (!isLoaded(src)) {
        src = lazyLoadingImage;
        if (!loading) {
          requestImage(props.src);
        }
      } else {
        isLazyImage = false;
      }
    }
  }, [lazyLoadingImage, src, isLazyImage, loading, props.src]);
  const isLoaded = (src2) => {
    return loadedAvatars.indexOf(src2) !== -1;
  };
  const requestImage = (src2) => {
    loading = true;
    const loaded = () => {
      loadedAvatars.push(src2);
      loading = false;
    };
    const img = document.createElement("img");
    img.src = src2;
    img.onload = loaded;
    img.onerror = loaded;
  };
  const stringToColour = (str) => {
    let hash = 0;
    for (let i = 0; i < str.length; i++) {
      hash = str.charCodeAt(i) + ((hash << 5) - hash);
    }
    let colour = "#";
    for (let i = 0; i < 3; i++) {
      let value = hash >> i * 8 & 255;
      value = value % 150 + 50;
      colour += `00${value.toString(16)}`.substr(-2);
    }
    return colour;
  };
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    "div",
    {
      className: (0, import_classnames.default)(
        "rce-avatar-container",
        type,
        size,
        props.className
      ),
      children: [
        props.letterItem ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "div",
          {
            className: "rce-avatar-letter-background",
            style: { backgroundColor: stringToColour(props.letterItem.id) },
            children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { className: "rce-avatar-letter", children: props.letterItem.letter })
          }
        ) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "img",
          {
            alt: props.alt,
            src,
            onError: props.onError,
            className: (0, import_classnames.default)("rce-avatar", {
              "rce-avatar-lazy": isLazyImage
            })
          }
        ),
        props.sideElement
      ]
    }
  );
};
var Avatar_default = Avatar;

// src/ChatItem/ChatItem.tsx
var import_date_fns = require("date-fns");
var import_classnames2 = __toESM(require("classnames"));
var import_md = require("react-icons/md");
var import_fa = require("react-icons/fa");
var import_jsx_runtime2 = require("react/jsx-runtime");
var ChatItem = (_a) => {
  var _b = _a, {
    avatarFlexible = false,
    date = /* @__PURE__ */ new Date(),
    unread = 0,
    statusColorType = "badge",
    lazyLoadingImage = void 0,
    onAvatarError = () => void 0
  } = _b, props = __objRest(_b, [
    "avatarFlexible",
    "date",
    "unread",
    "statusColorType",
    "lazyLoadingImage",
    "onAvatarError"
  ]);
  const [onHoverTool, setOnHoverTool] = (0, import_react2.useState)(false);
  const [onDrag, setOnDrag] = (0, import_react2.useState)(false);
  (0, import_react2.useEffect)(() => {
    if (typeof props.setDragStates === "function") {
      props.setDragStates(!onDrag);
    }
  }, [props.setDragStates, onDrag]);
  const handleOnMouseEnter = () => setOnHoverTool(true);
  const handleOnMouseLeave = () => setOnHoverTool(false);
  const handleOnClick = (e) => {
    e.preventDefault();
    if (onHoverTool) return;
    if (typeof props.onClick === "function") {
      props.onClick(e);
    }
  };
  const onDragOver = (e, id) => {
    if (typeof props.onDragOver === "function") {
      props.onDragOver(e, id);
    }
  };
  const onDragEnter = (e, id) => {
    if (typeof props.onDragEnter === "function") {
      props.onDragEnter(e, id);
    }
    if (!onDrag) {
      setOnDrag(true);
    }
  };
  const onDragLeave = (e, id) => {
    if (typeof props.onDragLeave === "function") {
      props.onDragLeave(e, id);
    }
    if (onDrag) {
      setOnDrag(false);
    }
  };
  const onDrop = (e, id) => {
    if (typeof props.onDrop === "function") {
      props.onDrop(e, id);
    }
    if (onDrag) {
      setOnDrag(false);
    }
  };
  const onExpandItem = (e, id) => {
    e.preventDefault();
    e.stopPropagation();
    if (typeof props.onExpandItem === "function") {
      props.onExpandItem(e, id);
    }
  };
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
    "div",
    {
      className: (0, import_classnames2.default)("rce-container-citem", props.className),
      onClick: handleOnClick,
      onKeyDown: console.log,
      onContextMenu: props.onContextMenu,
      children: /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
        "div",
        {
          className: "rce-citem",
          onDragOver: (e) => onDragOver(e, props.id),
          onDragEnter: (e) => onDragEnter(e, props.id),
          onDragLeave: (e) => onDragLeave(e, props.id),
          onDrop: (e) => onDrop(e, props.id),
          children: [
            props.onDragComponent && onDrag && props.onDragComponent,
            (onDrag && !props.onDragComponent || !onDrag) && /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
              /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
                "div",
                {
                  className: (0, import_classnames2.default)("rce-citem-avatar", {
                    "rce-citem-status-encircle": statusColorType === "encircle"
                  }),
                  children: [
                    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                      Avatar_default,
                      {
                        src: props.avatar,
                        alt: props.alt,
                        className: statusColorType === "encircle" ? "rce-citem-avatar-encircle-status" : "",
                        size: props.avatarSize || "large",
                        letterItem: props.letterItem,
                        sideElement: props.statusColor ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                          "span",
                          {
                            className: "rce-citem-status",
                            style: statusColorType === "encircle" ? { border: `solid 2px ${props.statusColor}` } : { backgroundColor: props.statusColor },
                            children: props.statusText
                          }
                        ) : null,
                        onError: onAvatarError,
                        lazyLoadingImage,
                        type: (0, import_classnames2.default)("circle", { flexible: avatarFlexible })
                      }
                    ),
                    props.subList && props.subList.length > 0 && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                      "button",
                      {
                        type: "button",
                        className: "rce-citem-expand-button",
                        onClick: (e) => onExpandItem(e, props.id),
                        children: props.expanded ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaArrowUp, {}) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaArrowDown, {})
                      }
                    )
                  ]
                },
                "avatar"
              ),
              /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-citem-body", children: [
                /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-citem-body--top", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-citem-body--top-title", children: props.title }),
                  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-citem-body--top-time", children: date && (props.dateString || (0, import_date_fns.format)(date, "HH:mm")) })
                ] }),
                /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-citem-body--bottom", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-citem-body--bottom-title", children: props.subtitle }),
                  /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
                    "div",
                    {
                      className: "rce-citem-body--bottom-tools",
                      onMouseEnter: handleOnMouseEnter,
                      onMouseLeave: handleOnMouseLeave,
                      children: [
                        props.showMute && /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
                          "div",
                          {
                            className: "rce-citem-body--bottom-tools-item",
                            onClick: props.onClickMute,
                            onKeyDown: console.log,
                            children: [
                              props.muted === true && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_md.MdVolumeOff, {}),
                              props.muted === false && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_md.MdVolumeUp, {})
                            ]
                          }
                        ),
                        props.showVideoCall && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                          "div",
                          {
                            className: "rce-citem-body--bottom-tools-item",
                            onClick: props.onClickVideoCall,
                            onKeyDown: console.log,
                            children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_md.MdVideoCall, {})
                          }
                        )
                      ]
                    }
                  ),
                  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-citem-body--bottom-tools-item-hidden-hover", children: props.showMute && props.muted && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-citem-body--bottom-tools-item", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_md.MdVolumeOff, {}) }) }),
                  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-citem-body--bottom-status", children: unread > 0 ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { children: unread }) : null }),
                  props.customStatusComponents ? props.customStatusComponents.map((item) => item) : null
                ] })
              ] }, "rce-citem-body")
            ] })
          ]
        }
      )
    },
    props.id
  );
};
var ChatItem_default = ChatItem;

// src/ChatList/ChatList.tsx
var import_jsx_runtime3 = require("react/jsx-runtime");
var import_react3 = require("react");
var list = [];
var ChatList = (props) => {
  const onClick = (item, index, event) => {
    if (props == null ? void 0 : props.onClick) {
      props == null ? void 0 : props.onClick(item, index, event);
    }
  };
  const onContextMenu = (item, index, event) => {
    if (props.onContextMenu instanceof Function)
      props.onContextMenu(item, index, event);
  };
  const onAvatarError = (item, index, event) => {
    if (props.onAvatarError instanceof Function)
      props.onAvatarError(item, index, event);
  };
  const setDragStates = (state) => {
    list.push(state);
  };
  const onDragLeaveMW = (e, id) => {
    var _a;
    if (list.length > 0)
      for (const item of list) {
        item instanceof Function && item(false);
      }
    (_a = props.onDragLeave) == null ? void 0 : _a.call(props, e, id.toString());
  };
  const onExpand = (item, index, event) => {
    if (props.onExpand instanceof Function) props.onExpand(item, index, event);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { className: (0, import_classnames3.default)("rce-container-clist", props.className), children: props.dataSource ? props.dataSource.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("div", { children: [
    /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
      ChatItem_default,
      __spreadProps(__spreadValues({}, x), {
        lazyLoadingImage: props == null ? void 0 : props.lazyLoadingImage,
        onAvatarError: (e) => onAvatarError(x, i, e),
        onContextMenu: (e) => onContextMenu(x, i, e),
        onClick: (e) => onClick(x, i, e),
        onClickMute: (e) => {
          var _a;
          return (_a = props.onClickMute) == null ? void 0 : _a.call(props, x, i, e);
        },
        onClickVideoCall: (e) => {
          var _a;
          return (_a = props.onClickVideoCall) == null ? void 0 : _a.call(props, x, i, e);
        },
        onDragOver: props == null ? void 0 : props.onDragOver,
        onDragEnter: props == null ? void 0 : props.onDragEnter,
        onDrop: props.onDrop,
        onDragLeave: (e) => onDragLeaveMW(e, i),
        onDragComponent: props.onDragComponent,
        setDragStates,
        onExpandItem: (e) => onExpand(x, i, e),
        expanded: x.expanded
      })
    ),
    x.subList && x.subList.length > 0 && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_jsx_runtime3.Fragment, { children: x.expanded && x.subList.map((sub, j) => /* @__PURE__ */ (0, import_react3.createElement)(
      ChatItem_default,
      __spreadProps(__spreadValues({}, sub), {
        className: "subitem",
        avatarSize: "xsmall",
        key: `${i}-${j.toString()}`,
        lazyLoadingImage: props == null ? void 0 : props.lazyLoadingImage,
        onAvatarError: (e) => onAvatarError(sub, j, e),
        onContextMenu: (e) => onContextMenu(sub, j, e),
        onClick: (e) => onClick(sub, j, e),
        onClickMute: (e) => {
          var _a;
          return (_a = props.onClickMute) == null ? void 0 : _a.call(props, sub, j, e);
        },
        onClickVideoCall: (e) => {
          var _a;
          return (_a = props.onClickVideoCall) == null ? void 0 : _a.call(props, sub, j, e);
        },
        onDragOver: props == null ? void 0 : props.onDragOver,
        onDragEnter: props == null ? void 0 : props.onDragEnter,
        onDrop: props.onDrop,
        onDragLeave: onDragLeaveMW,
        onDragComponent: props.onDragComponent,
        setDragStates
      })
    )) })
  ] }, i.toString())) : null });
};
var ChatList_default = ChatList;
