"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/FileMessage/FileMessage.tsx
var FileMessage_exports = {};
__export(FileMessage_exports, {
  default: () => FileMessage_default
});
module.exports = __toCommonJS(FileMessage_exports);
var import_fa = require("react-icons/fa");

// src/Circle/Circle.tsx
var import_react = require("react");
var import_progressbar = require("progressbar.js");
var import_jsx_runtime = require("react/jsx-runtime");
var wrapper;
var ProgressCircle = ({
  animate,
  progressOptions,
  className,
  progress = 0
}) => {
  const animateProgress = (0, import_react.useMemo)(() => progress, [progress]);
  const bar = (0, import_react.useMemo)(() => {
    wrapper = document.createElement("div");
    return new import_progressbar.Circle(wrapper, progressOptions);
  }, [progressOptions]);
  const node = (0, import_react.useCallback)((node2) => {
    if (node2) {
      node2.appendChild(wrapper);
    }
  }, []);
  (0, import_react.useEffect)(() => {
    if (animate) {
      bar.animate(animateProgress);
    }
  }, [animate, animateProgress, bar]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className, ref: node });
};
var Circle_default = ProgressCircle;

// src/FileMessage/FileMessage.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var FileMessage = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j;
  const progressOptions = {
    strokeWidth: 5,
    color: "#333",
    trailColor: "#aaa",
    trailWidth: 5,
    step: (state, circle) => {
      circle.path.setAttribute("trail", state.color);
      circle.path.setAttribute("trailwidth-width", state.width);
      const value = Math.round(circle.value() * 100);
      if (value === 0) circle.setText("");
      else circle.setText(value);
    }
  };
  const error = ((_a = props == null ? void 0 : props.data) == null ? void 0 : _a.status) && ((_b = props == null ? void 0 : props.data) == null ? void 0 : _b.status.error) === true;
  const onClick = (e) => {
    var _a2, _b2, _c2;
    if (!((_a2 = props == null ? void 0 : props.data) == null ? void 0 : _a2.status)) return;
    if (!((_b2 = props == null ? void 0 : props.data) == null ? void 0 : _b2.status.download) && props.onDownload instanceof Function)
      props.onDownload(e);
    else if (((_c2 = props == null ? void 0 : props.data) == null ? void 0 : _c2.status.download) && props.onOpen instanceof Function)
      props.onOpen(e);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-file", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("button", { onClick, children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mbox-file--icon", children: [
      /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaFile, { color: "#aaa" }),
      ((_c = props == null ? void 0 : props.data) == null ? void 0 : _c.size) ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-file--size", children: props == null ? void 0 : props.data.size }) : null
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-file--text", children: props.text }),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mbox-file--buttons", children: [
      error && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { className: "rce-error-button", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaExclamationTriangle, { color: "#ff3d3d" }) }),
      !error && ((_d = props == null ? void 0 : props.data) == null ? void 0 : _d.status) && !((_e = props == null ? void 0 : props.data) == null ? void 0 : _e.status.download) && !((_f = props == null ? void 0 : props.data) == null ? void 0 : _f.status.click) && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaCloudDownloadAlt, { color: "#aaa" }),
      !error && ((_g = props == null ? void 0 : props.data) == null ? void 0 : _g.status) && typeof ((_h = props == null ? void 0 : props.data) == null ? void 0 : _h.status.loading) === "number" && ((_i = props == null ? void 0 : props.data) == null ? void 0 : _i.status.loading) !== 0 && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
        Circle_default,
        {
          animate: !!((_j = props == null ? void 0 : props.data) == null ? void 0 : _j.status.loading),
          className: "rce-mbox-file--loading",
          progressOptions
        }
      )
    ] })
  ] }) });
};
var FileMessage_default = FileMessage;
