"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Input/Input.tsx
var Input_exports = {};
__export(Input_exports, {
  default: () => Input_default
});
module.exports = __toCommonJS(Input_exports);
var import_react = require("react");
var import_classnames = __toESM(require("classnames"));
var import_jsx_runtime = require("react/jsx-runtime");
var Input = (_a) => {
  var _b = _a, {
    type = "text",
    multiline = false,
    minHeight = 25,
    maxHeight = 200,
    autoHeight = true,
    autofocus = false
  } = _b, props = __objRest(_b, [
    "type",
    "multiline",
    "minHeight",
    "maxHeight",
    "autoHeight",
    "autofocus"
  ]);
  var _a2, _b2, _c;
  (0, import_react.useEffect)(() => {
    var _a3, _b3;
    if (autofocus) (_b3 = (_a3 = props.reference) == null ? void 0 : _a3.current) == null ? void 0 : _b3.focus();
    if (props.clear instanceof Function) {
      props.clear(clear);
    }
  }, [autofocus, props.clear, (_b2 = (_a2 = props.reference) == null ? void 0 : _a2.current) == null ? void 0 : _b2.focus]);
  const onChangeEvent = ({
    ev,
    target
  }) => {
    const el = target;
    if (multiline) {
      if (autoHeight) {
        if (el.style.height !== `${minHeight}px`) {
          el.style.height = `${minHeight}px`;
        }
        let height = "";
        if (el.scrollHeight <= maxHeight) height = `${el.scrollHeight}px`;
        else height = `${maxHeight}px`;
        if (el.style.height !== height) {
          el.style.height = height;
        }
      }
    }
    if (props.maxlength && (el.value || "").length > props.maxlength) {
      if (props.onMaxLengthExceed instanceof Function)
        props.onMaxLengthExceed();
      if (props.reference) {
        props.reference.current.value = (el.value || "").substring(
          0,
          props.maxlength
        );
      }
      return;
    }
    if (ev && props.onChange instanceof Function) props.onChange({ ev });
  };
  const clear = () => {
    var _a3, _b3, _c2;
    const current = {
      FAKE_EVENT: true,
      target: (_a3 = props.reference) == null ? void 0 : _a3.current
    };
    if ((_c2 = (_b3 = props.reference) == null ? void 0 : _b3.current) == null ? void 0 : _c2.value) {
      props.reference.current.value = "";
    }
    onChangeEvent(current);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: (0, import_classnames.default)("rce-container-input", props.className), children: [
    props.leftButtons && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "rce-input-buttons", children: props.leftButtons }),
    !multiline ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      "input",
      {
        ref: props.reference,
        type,
        className: (0, import_classnames.default)("rce-input"),
        placeholder: props.placeholder,
        defaultValue: props.defaultValue,
        style: props.inputStyle,
        onChange: (e) => {
          var _a3;
          return onChangeEvent({ ev: e, target: (_a3 = props.reference) == null ? void 0 : _a3.current });
        },
        onCopy: props.onCopy,
        onCut: props.onCut,
        onPaste: props.onPaste,
        onBlur: props.onBlur,
        onFocus: props.onFocus,
        onSelect: props.onSelect,
        onSubmit: props.onSubmit,
        onReset: props.onReset,
        onKeyDown: props.onKeyDown,
        onKeyPress: props.onKeyPress,
        onKeyUp: props.onKeyUp,
        value: props.value
      }
    ) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      "textarea",
      {
        ref: props.reference,
        className: (0, import_classnames.default)("rce-input", "rce-input-textarea"),
        placeholder: props.placeholder,
        defaultValue: props.defaultValue,
        style: props.inputStyle,
        onChange: (e) => {
          var _a3;
          return onChangeEvent({ ev: e, target: (_a3 = props.reference) == null ? void 0 : _a3.current });
        },
        onCopy: props.onCopy,
        onCut: props.onCut,
        onPaste: props.onPaste,
        onBlur: props.onBlur,
        onFocus: props.onFocus,
        onSelect: props.onSelect,
        onSubmit: props.onSubmit,
        onReset: props.onReset,
        onKeyDown: props.onKeyDown,
        onKeyPress: props.onKeyPress,
        onKeyUp: props.onKeyUp,
        children: props.defaultValue ? (_c = props == null ? void 0 : props.value) != null ? _c : null : null
      }
    ),
    props.rightButtons && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "rce-input-buttons", children: props.rightButtons })
  ] });
};
var Input_default = Input;
