"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/LocationMessage/LocationMessage.tsx
var LocationMessage_exports = {};
__export(LocationMessage_exports, {
  default: () => LocationMessage_default
});
module.exports = __toCommonJS(LocationMessage_exports);
var import_classnames = __toESM(require("classnames"));

// src/constants.ts
var STATIC_URL = "https://maps.googleapis.com/maps/api/staticmap?markers=color:MARKER_COLOR|LATITUDE,LONGITUDE&zoom=ZOOM&size=270x200&scale=2&key=KEY";
var MAP_URL = "https://www.google.com/maps/search/?api=1&query=LATITUDE,LONGITUDE&zoom=ZOOM";

// src/LocationMessage/LocationMessage.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var LocationMessage = (_a) => {
  var _b = _a, {
    markerColor = "red",
    target = "_blank",
    zoom = "14"
  } = _b, props = __objRest(_b, [
    "markerColor",
    "target",
    "zoom"
  ]);
  var _a2, _b2;
  const buildURL = (url) => {
    var _a3, _b3, _c, _d, _e;
    return url.replace(/LATITUDE/g, (_b3 = (_a3 = props == null ? void 0 : props.data) == null ? void 0 : _a3.latitude.toString()) != null ? _b3 : "0").replace(/LONGITUDE/g, (_d = (_c = props == null ? void 0 : props.data) == null ? void 0 : _c.longitude.toString()) != null ? _d : "0").replace("MARKER_COLOR", markerColor).replace("ZOOM", zoom).replace("KEY", (_e = props == null ? void 0 : props.apiKey) != null ? _e : "");
  };
  const className = () => {
    let _className = (0, import_classnames.default)("rce-mbox-location", props.className);
    if (props.text) {
      _className = (0, import_classnames.default)(_className, "rce-mbox-location-has-text");
    }
    return _className;
  };
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: "rce-container-lmsg", children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      "a",
      {
        onClick: props.onOpen,
        target,
        href: props.href || props.src || buildURL(((_a2 = props.data) == null ? void 0 : _a2.mapURL) || MAP_URL),
        className: className(),
        children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "img",
          {
            alt: props.alt,
            onError: props.onError,
            className: "rce-mbox-location-img",
            src: props.src || buildURL(((_b2 = props.data) == null ? void 0 : _b2.staticURL) || STATIC_URL)
          }
        )
      }
    ),
    props.text && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "rce-mbox-text rce-mbox-location-text", children: props.text })
  ] });
};
var LocationMessage_default = LocationMessage;
