"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/MeetingItem/MeetingItem.tsx
var MeetingItem_exports = {};
__export(MeetingItem_exports, {
  default: () => MeetingItem_default
});
module.exports = __toCommonJS(MeetingItem_exports);
var import_md = require("react-icons/md");

// src/Avatar/Avatar.tsx
var import_react = require("react");
var import_classnames = __toESM(require("classnames"));
var import_jsx_runtime = require("react/jsx-runtime");
var Avatar = (_a) => {
  var _b = _a, {
    type = "default",
    size = "default",
    lazyLoadingImage = void 0
  } = _b, props = __objRest(_b, [
    "type",
    "size",
    "lazyLoadingImage"
  ]);
  const loadedAvatars = [];
  let loading = false;
  let src = props.src;
  let isLazyImage = false;
  (0, import_react.useEffect)(() => {
    if (lazyLoadingImage) {
      isLazyImage = true;
      if (!isLoaded(src)) {
        src = lazyLoadingImage;
        if (!loading) {
          requestImage(props.src);
        }
      } else {
        isLazyImage = false;
      }
    }
  }, [lazyLoadingImage, src, isLazyImage, loading, props.src]);
  const isLoaded = (src2) => {
    return loadedAvatars.indexOf(src2) !== -1;
  };
  const requestImage = (src2) => {
    loading = true;
    const loaded = () => {
      loadedAvatars.push(src2);
      loading = false;
    };
    const img = document.createElement("img");
    img.src = src2;
    img.onload = loaded;
    img.onerror = loaded;
  };
  const stringToColour = (str) => {
    let hash = 0;
    for (let i = 0; i < str.length; i++) {
      hash = str.charCodeAt(i) + ((hash << 5) - hash);
    }
    let colour = "#";
    for (let i = 0; i < 3; i++) {
      let value = hash >> i * 8 & 255;
      value = value % 150 + 50;
      colour += `00${value.toString(16)}`.substr(-2);
    }
    return colour;
  };
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    "div",
    {
      className: (0, import_classnames.default)(
        "rce-avatar-container",
        type,
        size,
        props.className
      ),
      children: [
        props.letterItem ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "div",
          {
            className: "rce-avatar-letter-background",
            style: { backgroundColor: stringToColour(props.letterItem.id) },
            children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { className: "rce-avatar-letter", children: props.letterItem.letter })
          }
        ) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "img",
          {
            alt: props.alt,
            src,
            onError: props.onError,
            className: (0, import_classnames.default)("rce-avatar", {
              "rce-avatar-lazy": isLazyImage
            })
          }
        ),
        props.sideElement
      ]
    }
  );
};
var Avatar_default = Avatar;

// src/MeetingItem/MeetingItem.tsx
var import_date_fns = require("date-fns");
var import_classnames2 = __toESM(require("classnames"));
var import_jsx_runtime2 = require("react/jsx-runtime");
var MeetingItem = (_a) => {
  var _b = _a, {
    subjectLimit = 60,
    onClick = () => void 0,
    avatarFlexible = false,
    date = /* @__PURE__ */ new Date(),
    lazyLoadingImage = void 0,
    avatarLimit = 5,
    avatars = [],
    audioMuted = true,
    onAvatarError = () => void 0,
    onMeetingClick = () => void 0,
    onShareClick = () => void 0
  } = _b, props = __objRest(_b, [
    "subjectLimit",
    "onClick",
    "avatarFlexible",
    "date",
    "lazyLoadingImage",
    "avatarLimit",
    "avatars",
    "audioMuted",
    "onAvatarError",
    "onMeetingClick",
    "onShareClick"
  ]);
  const statusColorType = props.statusColorType;
  const AVATAR_LIMIT = avatarLimit;
  const dateText = date && (props.dateString || (0, import_date_fns.format)(date, "yyyy-MM-dd HH:mm:ss")) || (/* @__PURE__ */ new Date()).toISOString();
  const subject = props.subject && subjectLimit && props.subject.substring(0, subjectLimit) + (props.subject.length > subjectLimit ? "..." : "");
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
    "div",
    {
      className: (0, import_classnames2.default)("rce-container-mtitem", props.className),
      onClick,
      onKeyDown: console.log,
      onContextMenu: props.onContextMenu,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("audio", { autoPlay: true, loop: true, muted: audioMuted, src: props.audioSource }),
        /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mtitem", children: [
          /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mtitem-top", children: [
            /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mtitem-subject", children: subject }),
            /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
              "div",
              {
                className: "rce-mtitem-share",
                onClick: onShareClick,
                onKeyDown: console.log,
                children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_md.MdLink, {})
              }
            )
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mtitem-body", children: [
            /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mtitem-body--avatars", children: [
              avatars == null ? void 0 : avatars.slice(0, AVATAR_LIMIT).map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                Avatar_default,
                {
                  src: x.src,
                  alt: x.alt,
                  className: x.statusColorType === "encircle" ? "rce-mtitem-avatar-encircle-status" : "",
                  size: "small",
                  letterItem: x.letterItem,
                  sideElement: x.statusColor ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                    "span",
                    {
                      className: "rce-mtitem-status",
                      style: statusColorType === "encircle" ? {
                        boxShadow: `inset 0 0 0 2px ${x.statusColor}, inset 0 0 0 5px #FFFFFF`
                      } : {
                        backgroundColor: x.statusColor
                      },
                      children: x.statusText
                    }
                  ) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, {}),
                  onError: onAvatarError,
                  lazyLoadingImage,
                  type: (0, import_classnames2.default)("circle", { flexible: avatarFlexible })
                },
                i.toString()
              )),
              avatars && AVATAR_LIMIT && avatars.length > AVATAR_LIMIT && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-avatar-container circle small rce-mtitem-letter", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { children: `+${avatars.length - AVATAR_LIMIT}` }) })
            ] }),
            /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mtitem-body--functions", children: [
              props.closable && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                "div",
                {
                  className: "rce-mtitem-closable",
                  onClick: props.onCloseClick,
                  onKeyDown: console.log,
                  children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_md.MdCall, {})
                }
              ),
              /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                "div",
                {
                  className: "rce-mtitem-button",
                  onClick: onMeetingClick,
                  onKeyDown: console.log,
                  children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_md.MdVideoCall, {})
                }
              )
            ] })
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mtitem-footer", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { className: "rce-mtitem-date", children: dateText }) })
        ] })
      ]
    }
  );
};
var MeetingItem_default = MeetingItem;
