"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/MeetingMessage/MeetingMessage.tsx
var MeetingMessage_exports = {};
__export(MeetingMessage_exports, {
  default: () => MeetingMessage_default
});
module.exports = __toCommonJS(MeetingMessage_exports);
var import_react3 = require("react");
var import_fa = require("react-icons/fa");
var import_hi = require("react-icons/hi");
var import_io = require("react-icons/io");
var import_md = require("react-icons/md");
var import_date_fns = require("date-fns");

// src/Avatar/Avatar.tsx
var import_react = require("react");
var import_classnames = __toESM(require("classnames"));
var import_jsx_runtime = require("react/jsx-runtime");
var Avatar = (_a) => {
  var _b = _a, {
    type = "default",
    size = "default",
    lazyLoadingImage = void 0
  } = _b, props = __objRest(_b, [
    "type",
    "size",
    "lazyLoadingImage"
  ]);
  const loadedAvatars = [];
  let loading = false;
  let src = props.src;
  let isLazyImage = false;
  (0, import_react.useEffect)(() => {
    if (lazyLoadingImage) {
      isLazyImage = true;
      if (!isLoaded(src)) {
        src = lazyLoadingImage;
        if (!loading) {
          requestImage(props.src);
        }
      } else {
        isLazyImage = false;
      }
    }
  }, [lazyLoadingImage, src, isLazyImage, loading, props.src]);
  const isLoaded = (src2) => {
    return loadedAvatars.indexOf(src2) !== -1;
  };
  const requestImage = (src2) => {
    loading = true;
    const loaded = () => {
      loadedAvatars.push(src2);
      loading = false;
    };
    const img = document.createElement("img");
    img.src = src2;
    img.onload = loaded;
    img.onerror = loaded;
  };
  const stringToColour = (str) => {
    let hash = 0;
    for (let i = 0; i < str.length; i++) {
      hash = str.charCodeAt(i) + ((hash << 5) - hash);
    }
    let colour = "#";
    for (let i = 0; i < 3; i++) {
      let value = hash >> i * 8 & 255;
      value = value % 150 + 50;
      colour += `00${value.toString(16)}`.substr(-2);
    }
    return colour;
  };
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    "div",
    {
      className: (0, import_classnames.default)(
        "rce-avatar-container",
        type,
        size,
        props.className
      ),
      children: [
        props.letterItem ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "div",
          {
            className: "rce-avatar-letter-background",
            style: { backgroundColor: stringToColour(props.letterItem.id) },
            children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { className: "rce-avatar-letter", children: props.letterItem.letter })
          }
        ) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "img",
          {
            alt: props.alt,
            src,
            onError: props.onError,
            className: (0, import_classnames.default)("rce-avatar", {
              "rce-avatar-lazy": isLazyImage
            })
          }
        ),
        props.sideElement
      ]
    }
  );
};
var Avatar_default = Avatar;

// src/Dropdown/Dropdown.tsx
var import_react2 = require("react");
var import_classnames3 = __toESM(require("classnames"));

// src/Button/Button.tsx
var import_classnames2 = __toESM(require("classnames"));
var import_jsx_runtime2 = require("react/jsx-runtime");
var Button = (_a) => {
  var _b = _a, {
    disabled = false,
    backgroundColor = "#3979aa",
    color = "white"
  } = _b, props = __objRest(_b, [
    "disabled",
    "backgroundColor",
    "color"
  ]);
  var _a2, _b2;
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
    "button",
    {
      type: (_a2 = props == null ? void 0 : props.type) != null ? _a2 : "button",
      ref: props.buttonRef,
      title: props.title,
      className: (0, import_classnames2.default)("rce-button", props.type, props.className),
      style: {
        backgroundColor,
        color,
        borderColor: backgroundColor
      },
      disabled,
      onClick: props.onClick,
      children: props.icon ? /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("span", { className: "rce-button-icon--container", children: [
        (props.icon.float === "right" || !props.icon.float) && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { children: props.text }),
        /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "span",
          {
            style: {
              float: (_b2 = props.icon.float) != null ? _b2 : "inherit",
              fontSize: props.icon.size || 12
            },
            className: "rce-button-icon",
            children: props.icon.component
          }
        ),
        props.icon.float === "left" && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { children: props.text })
      ] }) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { children: props.text })
    }
  );
};
var Button_default = Button;

// src/Dropdown/Dropdown.tsx
var import_jsx_runtime3 = require("react/jsx-runtime");
var Dropdown = (_a) => {
  var _b = _a, {
    animationPosition = "nortwest",
    animationType = "default"
  } = _b, props = __objRest(_b, [
    "animationPosition",
    "animationType"
  ]);
  var _a2;
  const [show, setShow] = (0, import_react2.useState)(void 0);
  const onBlur = () => {
    if (show === true) setShow(false);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)(
    "div",
    {
      className: (0, import_classnames3.default)("rce-dropdown-container", props.className),
      onBlur,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(Button_default, __spreadProps(__spreadValues({}, props.buttonProps), { onClick: () => setShow(!show) })),
        /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
          "div",
          {
            className: (0, import_classnames3.default)(
              "rce-dropdown",
              animationType,
              `rce-dropdown-open__${animationPosition}`,
              { "dropdown-hide": show === false },
              { "dropdown-show": show === true }
            ),
            children: /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("ul", { children: [
              props.title && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("span", { className: "rce-dropdown-title", children: props.title }),
              (_a2 = props.items) == null ? void 0 : _a2.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
                "li",
                {
                  onMouseDown: (e) => props.onSelect instanceof Function ? props.onSelect(e, i) : void 0,
                  children: typeof x !== "string" ? x.icon ? /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("span", { className: "rce-button-icon--container", children: [
                    (x.icon.float === "right" || !x.icon.float) && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("button", { type: "button", className: "rce-button-link", children: x.text }),
                    /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
                      "span",
                      {
                        style: {
                          float: x.icon.float,
                          color: x.icon.color,
                          fontSize: x.icon.size || 12
                        },
                        className: (0, import_classnames3.default)(
                          "rce-button-icon",
                          x.icon.className
                        ),
                        children: x.icon.component
                      }
                    ),
                    x.icon.float === "left" && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("button", { type: "button", className: "rce-button-link", children: x.text })
                  ] }) : /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("button", { type: "button", className: "rce-button-link", children: x.text }) : /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("button", { type: "button", className: "rce-button-link", children: x })
                },
                i.toString()
              ))
            ] })
          }
        )
      ]
    }
  );
};
var Dropdown_default = Dropdown;

// src/MeetingMessage/MeetingMessage.tsx
var import_classnames4 = __toESM(require("classnames"));
var import_jsx_runtime4 = require("react/jsx-runtime");
var MeetingMessage = (_a) => {
  var _b = _a, {
    date,
    dateString,
    title,
    subject,
    collapseTitle,
    moreItems,
    participants,
    dataSource,
    onClick,
    onMeetingTitleClick,
    onMeetingVideoLinkClick,
    onMeetingMoreSelect
  } = _b, props = __objRest(_b, [
    "date",
    "dateString",
    "title",
    "subject",
    "collapseTitle",
    "moreItems",
    "participants",
    "dataSource",
    "onClick",
    "onMeetingTitleClick",
    "onMeetingVideoLinkClick",
    "onMeetingMoreSelect"
  ]);
  const [toggle, setToggle] = (0, import_react3.useState)(false);
  const PARTICIPANT_LIMIT = props.participantsLimit || Number.POSITIVE_INFINITY;
  const dateText = dateString ? dateString : date && (0, import_date_fns.format)(date, "yyyy-MM-dd HH:mm:ss");
  const _onMeetingLinkClick = (item, index, event) => {
    if (onMeetingTitleClick instanceof Function)
      onMeetingTitleClick(item, index, event);
  };
  const _onMeetingVideoLinkClick = (item, index, event) => {
    if (onMeetingVideoLinkClick instanceof Function)
      onMeetingVideoLinkClick(item, index, event);
  };
  const toggleClick = () => {
    setToggle(!toggle);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mbox-mtmg", children: /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mtmg", children: [
    /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mtmg-subject", children: subject || "Unknown Meeting" }),
    /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)(
      "div",
      {
        className: "rce-mtmg-body",
        onClick,
        onKeyDown: console.log,
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mtmg-item", children: [
            /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(import_fa.FaCalendar, {}),
            /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mtmg-content", children: [
              /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("span", { className: "rce-mtmg-title", children: title }),
              /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("span", { className: "rce-mtmg-date", children: dateText })
            ] })
          ] }),
          onMeetingMoreSelect && moreItems && moreItems.length > 0 && /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
            Dropdown_default,
            {
              animationType: "bottom",
              animationPosition: "norteast",
              buttonProps: {
                className: "rce-mtmg-right-icon",
                icon: {
                  component: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(import_md.MdMoreHoriz, {}),
                  size: 24
                }
              },
              items: moreItems,
              onSelect: (e) => onMeetingMoreSelect == null ? void 0 : onMeetingMoreSelect(e)
            }
          ) })
        ]
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
      "div",
      {
        className: "rce-mtmg-body-bottom",
        onClick: toggleClick,
        onKeyDown: console.log,
        children: toggle ? /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mtmg-bottom--tptitle", children: [
          /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(import_fa.FaCaretDown, {}),
          /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("span", { children: collapseTitle })
        ] }) : /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mtmg-body-bottom--bttitle", children: [
          /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(import_fa.FaCaretRight, {}),
          /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("span", { children: [
            participants == null ? void 0 : participants.slice(0, PARTICIPANT_LIMIT).map((x) => x.title || "Unknow").join(", "),
            participants && PARTICIPANT_LIMIT && participants.length > PARTICIPANT_LIMIT && `, +${participants.length - PARTICIPANT_LIMIT}`
          ] })
        ] })
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
      "div",
      {
        className: (0, import_classnames4.default)("rce-mtmg-toogleContent", {
          "rce-mtmg-toogleContent--click": toggle
        }),
        children: dataSource == null ? void 0 : dataSource.map((x, i) => {
          var _a2, _b2;
          return /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { children: [
            !x.event && /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mitem", children: [
              /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
                "div",
                {
                  className: (0, import_classnames4.default)("rce-mitem avatar", {
                    "rce-mitem no-avatar": !x.avatar
                  }),
                  children: x.avatar ? /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(Avatar_default, { src: x.avatar }) : /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(import_io.IoMdChatboxes, {})
                }
              ),
              /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mitem-body", children: [
                /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mitem-body--top", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
                    "div",
                    {
                      className: "rce-mitem-body--top-title",
                      onClick: (e) => _onMeetingLinkClick(x, i, e),
                      onKeyDown: console.log,
                      children: x.title
                    }
                  ),
                  /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && x.date && (0, import_date_fns.format)(x.date, "yyyy-MM-dd HH:mm") })
                ] }),
                /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mitem-body--bottom", children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mitem-body--bottom-title", children: x.message }) })
              ] })
            ] }),
            x.event && /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mitem-event", children: /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mitem-bottom-body", children: [
              /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mitem-body avatar", children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(import_hi.HiOutlineVideoCamera, {}) }),
              /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mitem-bottom-body-top", children: [
                x.event.title,
                /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && (0, import_date_fns.format)(x.date, "yyyy-MM-dd HH:mm") }),
                /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mitem-avatar-content", children: /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mitem-avatar", children: [
                  (_b2 = x.event.avatars) == null ? void 0 : _b2.slice(0, PARTICIPANT_LIMIT).map((x2, i2) => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(Avatar_default, { src: x2.src }, i2.toString())),
                  x.event.avatars && x.event.avatarsLimit && x.event.avatars.length > x.event.avatarsLimit && /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
                    "div",
                    {
                      className: "rce-mitem-length rce-mitem-tooltip",
                      tooltip: x.event.avatars.slice(
                        x.event.avatarsLimit,
                        x.event.avatars.length
                      ).map((avatar) => avatar.title).join(",").toString(),
                      children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("span", { className: "rce-mitem-tooltip-text", children: `+${x.event.avatars.length - x.event.avatarsLimit}` })
                    }
                  )
                ] }) }),
                x.record && /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mtmg-call-record", children: /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mtmg-call-body", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)(
                    "div",
                    {
                      onClick: (e) => _onMeetingVideoLinkClick(x, i, e),
                      onKeyDown: console.log,
                      className: "rce-mtmg-call-avatars",
                      children: [
                        /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
                          Avatar_default,
                          {
                            className: "rce-mtmg-call-avatars",
                            src: x.record.avatar
                          }
                        ),
                        /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mtmg-record-time", children: x.record.time })
                      ]
                    }
                  ),
                  /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "rce-mtmg-call-body-title", children: [
                    /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("span", { children: x.record.title }),
                    /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-mtmg-call-body-bottom", children: x.record.savedBy })
                  ] })
                ] }) })
              ] })
            ] }) })
          ] }, (_a2 = x.id) != null ? _a2 : i.toString());
        })
      }
    )
  ] }) });
};
var MeetingMessage_default = MeetingMessage;
