"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/PhotoMessage/PhotoMessage.tsx
var PhotoMessage_exports = {};
__export(PhotoMessage_exports, {
  default: () => PhotoMessage_default
});
module.exports = __toCommonJS(PhotoMessage_exports);
var import_fa = require("react-icons/fa");

// src/Circle/Circle.tsx
var import_react = require("react");
var import_progressbar = require("progressbar.js");
var import_jsx_runtime = require("react/jsx-runtime");
var wrapper;
var ProgressCircle = ({
  animate,
  progressOptions,
  className,
  progress = 0
}) => {
  const animateProgress = (0, import_react.useMemo)(() => progress, [progress]);
  const bar = (0, import_react.useMemo)(() => {
    wrapper = document.createElement("div");
    return new import_progressbar.Circle(wrapper, progressOptions);
  }, [progressOptions]);
  const node = (0, import_react.useCallback)((node2) => {
    if (node2) {
      node2.appendChild(wrapper);
    }
  }, []);
  (0, import_react.useEffect)(() => {
    if (animate) {
      bar.animate(animateProgress);
    }
  }, [animate, animateProgress, bar]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className, ref: node });
};
var Circle_default = ProgressCircle;

// src/PhotoMessage/PhotoMessage.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var PhotoMessage = ({
  text,
  data,
  onDownload,
  onLoad,
  onOpen,
  onPhotoError
}) => {
  var _a, _b;
  const progressOptions = {
    strokeWidth: 2.3,
    color: "#efe",
    trailColor: "#aaa",
    trailWidth: 1,
    step: (state, circle) => {
      var _a2, _b2;
      circle.path.setAttribute("trail", (_a2 = state == null ? void 0 : state.state) == null ? void 0 : _a2.color);
      circle.path.setAttribute("trailwidth-width", (_b2 = state == null ? void 0 : state.state) == null ? void 0 : _b2.width);
      const value = Math.round(circle.value() * 100);
      if (value === 0) circle.setText("");
      else circle.setText(value);
    }
  };
  const error = (data == null ? void 0 : data.status) && (data == null ? void 0 : data.status.error) === true;
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mbox-photo", children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
      "div",
      {
        className: "rce-mbox-photo--img",
        style: __spreadValues({}, (data == null ? void 0 : data.width) && (data == null ? void 0 : data.height) && {
          width: data.width,
          height: data.height
        }),
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
            "img",
            {
              src: data == null ? void 0 : data.uri,
              alt: data == null ? void 0 : data.alt,
              onClick: onOpen,
              onKeyDown: console.log,
              onLoad,
              onError: onPhotoError
            }
          ),
          error && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-photo--img__block", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { className: "rce-mbox-photo--img__block-item rce-mbox-photo--error", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaExclamationTriangle, {}) }) }),
          !error && (data == null ? void 0 : data.status) && !((_a = data == null ? void 0 : data.status) == null ? void 0 : _a.download) && /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mbox-photo--img__block", children: [
            !(data == null ? void 0 : data.status.click) && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
              "button",
              {
                type: "button",
                onClick: onDownload,
                onKeyDown: console.log,
                className: "rce-mbox-photo--img__block-item rce-mbox-photo--download",
                children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaCloudDownloadAlt, {})
              }
            ),
            typeof (data == null ? void 0 : data.status.loading) === "number" && (data == null ? void 0 : data.status.loading) !== 0 && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
              Circle_default,
              {
                animate: (_b = data == null ? void 0 : data.status.loading) != null ? _b : false,
                progressOptions,
                className: "rce-mbox-photo--img__block-item"
              }
            )
          ] })
        ]
      }
    ),
    text && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-text", children: text })
  ] });
};
var PhotoMessage_default = PhotoMessage;
