import {
  Circle_default
} from "./chunk-W2JZF6FY.mjs";

// src/FileMessage/FileMessage.tsx
import {
  FaFile,
  FaCloudDownloadAlt,
  FaExclamationTriangle
} from "react-icons/fa";
import { jsx, jsxs } from "react/jsx-runtime";
var FileMessage = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j;
  const progressOptions = {
    strokeWidth: 5,
    color: "#333",
    trailColor: "#aaa",
    trailWidth: 5,
    step: (state, circle) => {
      circle.path.setAttribute("trail", state.color);
      circle.path.setAttribute("trailwidth-width", state.width);
      const value = Math.round(circle.value() * 100);
      if (value === 0) circle.setText("");
      else circle.setText(value);
    }
  };
  const error = ((_a = props == null ? void 0 : props.data) == null ? void 0 : _a.status) && ((_b = props == null ? void 0 : props.data) == null ? void 0 : _b.status.error) === true;
  const onClick = (e) => {
    var _a2, _b2, _c2;
    if (!((_a2 = props == null ? void 0 : props.data) == null ? void 0 : _a2.status)) return;
    if (!((_b2 = props == null ? void 0 : props.data) == null ? void 0 : _b2.status.download) && props.onDownload instanceof Function)
      props.onDownload(e);
    else if (((_c2 = props == null ? void 0 : props.data) == null ? void 0 : _c2.status.download) && props.onOpen instanceof Function)
      props.onOpen(e);
  };
  return /* @__PURE__ */ jsx("div", { className: "rce-mbox-file", children: /* @__PURE__ */ jsxs("button", { onClick, children: [
    /* @__PURE__ */ jsxs("div", { className: "rce-mbox-file--icon", children: [
      /* @__PURE__ */ jsx(FaFile, { color: "#aaa" }),
      ((_c = props == null ? void 0 : props.data) == null ? void 0 : _c.size) ? /* @__PURE__ */ jsx("div", { className: "rce-mbox-file--size", children: props == null ? void 0 : props.data.size }) : null
    ] }),
    /* @__PURE__ */ jsx("div", { className: "rce-mbox-file--text", children: props.text }),
    /* @__PURE__ */ jsxs("div", { className: "rce-mbox-file--buttons", children: [
      error && /* @__PURE__ */ jsx("span", { className: "rce-error-button", children: /* @__PURE__ */ jsx(FaExclamationTriangle, { color: "#ff3d3d" }) }),
      !error && ((_d = props == null ? void 0 : props.data) == null ? void 0 : _d.status) && !((_e = props == null ? void 0 : props.data) == null ? void 0 : _e.status.download) && !((_f = props == null ? void 0 : props.data) == null ? void 0 : _f.status.click) && /* @__PURE__ */ jsx(FaCloudDownloadAlt, { color: "#aaa" }),
      !error && ((_g = props == null ? void 0 : props.data) == null ? void 0 : _g.status) && typeof ((_h = props == null ? void 0 : props.data) == null ? void 0 : _h.status.loading) === "number" && ((_i = props == null ? void 0 : props.data) == null ? void 0 : _i.status.loading) !== 0 && /* @__PURE__ */ jsx(
        Circle_default,
        {
          animate: !!((_j = props == null ? void 0 : props.data) == null ? void 0 : _j.status.loading),
          className: "rce-mbox-file--loading",
          progressOptions
        }
      )
    ] })
  ] }) });
};
var FileMessage_default = FileMessage;

export {
  FileMessage_default
};
