import {
  Avatar_default
} from "./chunk-JASX4HQP.mjs";
import {
  __objRest
} from "./chunk-FWCSY2DS.mjs";

// src/ChatItem/ChatItem.tsx
import { useState, useEffect } from "react";
import { format } from "date-fns";
import classNames from "classnames";
import { MdVideoCall, MdVolumeOff, MdVolumeUp } from "react-icons/md";
import { FaArrowDown, FaArrowUp } from "react-icons/fa";
import { Fragment, jsx, jsxs } from "react/jsx-runtime";
var ChatItem = (_a) => {
  var _b = _a, {
    avatarFlexible = false,
    date = /* @__PURE__ */ new Date(),
    unread = 0,
    statusColorType = "badge",
    lazyLoadingImage = void 0,
    onAvatarError = () => void 0
  } = _b, props = __objRest(_b, [
    "avatarFlexible",
    "date",
    "unread",
    "statusColorType",
    "lazyLoadingImage",
    "onAvatarError"
  ]);
  const [onHoverTool, setOnHoverTool] = useState(false);
  const [onDrag, setOnDrag] = useState(false);
  useEffect(() => {
    if (typeof props.setDragStates === "function") {
      props.setDragStates(!onDrag);
    }
  }, [props.setDragStates, onDrag]);
  const handleOnMouseEnter = () => setOnHoverTool(true);
  const handleOnMouseLeave = () => setOnHoverTool(false);
  const handleOnClick = (e) => {
    e.preventDefault();
    if (onHoverTool) return;
    if (typeof props.onClick === "function") {
      props.onClick(e);
    }
  };
  const onDragOver = (e, id) => {
    if (typeof props.onDragOver === "function") {
      props.onDragOver(e, id);
    }
  };
  const onDragEnter = (e, id) => {
    if (typeof props.onDragEnter === "function") {
      props.onDragEnter(e, id);
    }
    if (!onDrag) {
      setOnDrag(true);
    }
  };
  const onDragLeave = (e, id) => {
    if (typeof props.onDragLeave === "function") {
      props.onDragLeave(e, id);
    }
    if (onDrag) {
      setOnDrag(false);
    }
  };
  const onDrop = (e, id) => {
    if (typeof props.onDrop === "function") {
      props.onDrop(e, id);
    }
    if (onDrag) {
      setOnDrag(false);
    }
  };
  const onExpandItem = (e, id) => {
    e.preventDefault();
    e.stopPropagation();
    if (typeof props.onExpandItem === "function") {
      props.onExpandItem(e, id);
    }
  };
  return /* @__PURE__ */ jsx(
    "div",
    {
      className: classNames("rce-container-citem", props.className),
      onClick: handleOnClick,
      onKeyDown: console.log,
      onContextMenu: props.onContextMenu,
      children: /* @__PURE__ */ jsxs(
        "div",
        {
          className: "rce-citem",
          onDragOver: (e) => onDragOver(e, props.id),
          onDragEnter: (e) => onDragEnter(e, props.id),
          onDragLeave: (e) => onDragLeave(e, props.id),
          onDrop: (e) => onDrop(e, props.id),
          children: [
            props.onDragComponent && onDrag && props.onDragComponent,
            (onDrag && !props.onDragComponent || !onDrag) && /* @__PURE__ */ jsxs(Fragment, { children: [
              /* @__PURE__ */ jsxs(
                "div",
                {
                  className: classNames("rce-citem-avatar", {
                    "rce-citem-status-encircle": statusColorType === "encircle"
                  }),
                  children: [
                    /* @__PURE__ */ jsx(
                      Avatar_default,
                      {
                        src: props.avatar,
                        alt: props.alt,
                        className: statusColorType === "encircle" ? "rce-citem-avatar-encircle-status" : "",
                        size: props.avatarSize || "large",
                        letterItem: props.letterItem,
                        sideElement: props.statusColor ? /* @__PURE__ */ jsx(
                          "span",
                          {
                            className: "rce-citem-status",
                            style: statusColorType === "encircle" ? { border: `solid 2px ${props.statusColor}` } : { backgroundColor: props.statusColor },
                            children: props.statusText
                          }
                        ) : null,
                        onError: onAvatarError,
                        lazyLoadingImage,
                        type: classNames("circle", { flexible: avatarFlexible })
                      }
                    ),
                    props.subList && props.subList.length > 0 && /* @__PURE__ */ jsx(
                      "button",
                      {
                        type: "button",
                        className: "rce-citem-expand-button",
                        onClick: (e) => onExpandItem(e, props.id),
                        children: props.expanded ? /* @__PURE__ */ jsx(FaArrowUp, {}) : /* @__PURE__ */ jsx(FaArrowDown, {})
                      }
                    )
                  ]
                },
                "avatar"
              ),
              /* @__PURE__ */ jsxs("div", { className: "rce-citem-body", children: [
                /* @__PURE__ */ jsxs("div", { className: "rce-citem-body--top", children: [
                  /* @__PURE__ */ jsx("div", { className: "rce-citem-body--top-title", children: props.title }),
                  /* @__PURE__ */ jsx("div", { className: "rce-citem-body--top-time", children: date && (props.dateString || format(date, "HH:mm")) })
                ] }),
                /* @__PURE__ */ jsxs("div", { className: "rce-citem-body--bottom", children: [
                  /* @__PURE__ */ jsx("div", { className: "rce-citem-body--bottom-title", children: props.subtitle }),
                  /* @__PURE__ */ jsxs(
                    "div",
                    {
                      className: "rce-citem-body--bottom-tools",
                      onMouseEnter: handleOnMouseEnter,
                      onMouseLeave: handleOnMouseLeave,
                      children: [
                        props.showMute && /* @__PURE__ */ jsxs(
                          "div",
                          {
                            className: "rce-citem-body--bottom-tools-item",
                            onClick: props.onClickMute,
                            onKeyDown: console.log,
                            children: [
                              props.muted === true && /* @__PURE__ */ jsx(MdVolumeOff, {}),
                              props.muted === false && /* @__PURE__ */ jsx(MdVolumeUp, {})
                            ]
                          }
                        ),
                        props.showVideoCall && /* @__PURE__ */ jsx(
                          "div",
                          {
                            className: "rce-citem-body--bottom-tools-item",
                            onClick: props.onClickVideoCall,
                            onKeyDown: console.log,
                            children: /* @__PURE__ */ jsx(MdVideoCall, {})
                          }
                        )
                      ]
                    }
                  ),
                  /* @__PURE__ */ jsx("div", { className: "rce-citem-body--bottom-tools-item-hidden-hover", children: props.showMute && props.muted && /* @__PURE__ */ jsx("div", { className: "rce-citem-body--bottom-tools-item", children: /* @__PURE__ */ jsx(MdVolumeOff, {}) }) }),
                  /* @__PURE__ */ jsx("div", { className: "rce-citem-body--bottom-status", children: unread > 0 ? /* @__PURE__ */ jsx("span", { children: unread }) : null }),
                  props.customStatusComponents ? props.customStatusComponents.map((item) => item) : null
                ] })
              ] }, "rce-citem-body")
            ] })
          ]
        }
      )
    },
    props.id
  );
};
var ChatItem_default = ChatItem;

export {
  ChatItem_default
};
