import {
  Avatar_default
} from "./chunk-JASX4HQP.mjs";
import {
  __objRest
} from "./chunk-FWCSY2DS.mjs";

// src/MeetingItem/MeetingItem.tsx
import { MdVideoCall, MdLink, MdCall } from "react-icons/md";
import { format } from "date-fns";
import classNames from "classnames";
import { Fragment, jsx, jsxs } from "react/jsx-runtime";
var MeetingItem = (_a) => {
  var _b = _a, {
    subjectLimit = 60,
    onClick = () => void 0,
    avatarFlexible = false,
    date = /* @__PURE__ */ new Date(),
    lazyLoadingImage = void 0,
    avatarLimit = 5,
    avatars = [],
    audioMuted = true,
    onAvatarError = () => void 0,
    onMeetingClick = () => void 0,
    onShareClick = () => void 0
  } = _b, props = __objRest(_b, [
    "subjectLimit",
    "onClick",
    "avatarFlexible",
    "date",
    "lazyLoadingImage",
    "avatarLimit",
    "avatars",
    "audioMuted",
    "onAvatarError",
    "onMeetingClick",
    "onShareClick"
  ]);
  const statusColorType = props.statusColorType;
  const AVATAR_LIMIT = avatarLimit;
  const dateText = date && (props.dateString || format(date, "yyyy-MM-dd HH:mm:ss")) || (/* @__PURE__ */ new Date()).toISOString();
  const subject = props.subject && subjectLimit && props.subject.substring(0, subjectLimit) + (props.subject.length > subjectLimit ? "..." : "");
  return /* @__PURE__ */ jsxs(
    "div",
    {
      className: classNames("rce-container-mtitem", props.className),
      onClick,
      onKeyDown: console.log,
      onContextMenu: props.onContextMenu,
      children: [
        /* @__PURE__ */ jsx("audio", { autoPlay: true, loop: true, muted: audioMuted, src: props.audioSource }),
        /* @__PURE__ */ jsxs("div", { className: "rce-mtitem", children: [
          /* @__PURE__ */ jsxs("div", { className: "rce-mtitem-top", children: [
            /* @__PURE__ */ jsx("div", { className: "rce-mtitem-subject", children: subject }),
            /* @__PURE__ */ jsx(
              "div",
              {
                className: "rce-mtitem-share",
                onClick: onShareClick,
                onKeyDown: console.log,
                children: /* @__PURE__ */ jsx(MdLink, {})
              }
            )
          ] }),
          /* @__PURE__ */ jsxs("div", { className: "rce-mtitem-body", children: [
            /* @__PURE__ */ jsxs("div", { className: "rce-mtitem-body--avatars", children: [
              avatars == null ? void 0 : avatars.slice(0, AVATAR_LIMIT).map((x, i) => /* @__PURE__ */ jsx(
                Avatar_default,
                {
                  src: x.src,
                  alt: x.alt,
                  className: x.statusColorType === "encircle" ? "rce-mtitem-avatar-encircle-status" : "",
                  size: "small",
                  letterItem: x.letterItem,
                  sideElement: x.statusColor ? /* @__PURE__ */ jsx(
                    "span",
                    {
                      className: "rce-mtitem-status",
                      style: statusColorType === "encircle" ? {
                        boxShadow: `inset 0 0 0 2px ${x.statusColor}, inset 0 0 0 5px #FFFFFF`
                      } : {
                        backgroundColor: x.statusColor
                      },
                      children: x.statusText
                    }
                  ) : /* @__PURE__ */ jsx(Fragment, {}),
                  onError: onAvatarError,
                  lazyLoadingImage,
                  type: classNames("circle", { flexible: avatarFlexible })
                },
                i.toString()
              )),
              avatars && AVATAR_LIMIT && avatars.length > AVATAR_LIMIT && /* @__PURE__ */ jsx("div", { className: "rce-avatar-container circle small rce-mtitem-letter", children: /* @__PURE__ */ jsx("span", { children: `+${avatars.length - AVATAR_LIMIT}` }) })
            ] }),
            /* @__PURE__ */ jsxs("div", { className: "rce-mtitem-body--functions", children: [
              props.closable && /* @__PURE__ */ jsx(
                "div",
                {
                  className: "rce-mtitem-closable",
                  onClick: props.onCloseClick,
                  onKeyDown: console.log,
                  children: /* @__PURE__ */ jsx(MdCall, {})
                }
              ),
              /* @__PURE__ */ jsx(
                "div",
                {
                  className: "rce-mtitem-button",
                  onClick: onMeetingClick,
                  onKeyDown: console.log,
                  children: /* @__PURE__ */ jsx(MdVideoCall, {})
                }
              )
            ] })
          ] }),
          /* @__PURE__ */ jsx("div", { className: "rce-mtitem-footer", children: /* @__PURE__ */ jsx("span", { className: "rce-mtitem-date", children: dateText }) })
        ] })
      ]
    }
  );
};
var MeetingItem_default = MeetingItem;

export {
  MeetingItem_default
};
