import {
  Circle_default
} from "./chunk-W2JZF6FY.mjs";
import {
  __spreadValues
} from "./chunk-FWCSY2DS.mjs";

// src/PhotoMessage/PhotoMessage.tsx
import { FaCloudDownloadAlt, FaExclamationTriangle } from "react-icons/fa";
import { jsx, jsxs } from "react/jsx-runtime";
var PhotoMessage = ({
  text,
  data,
  onDownload,
  onLoad,
  onOpen,
  onPhotoError
}) => {
  var _a, _b;
  const progressOptions = {
    strokeWidth: 2.3,
    color: "#efe",
    trailColor: "#aaa",
    trailWidth: 1,
    step: (state, circle) => {
      var _a2, _b2;
      circle.path.setAttribute("trail", (_a2 = state == null ? void 0 : state.state) == null ? void 0 : _a2.color);
      circle.path.setAttribute("trailwidth-width", (_b2 = state == null ? void 0 : state.state) == null ? void 0 : _b2.width);
      const value = Math.round(circle.value() * 100);
      if (value === 0) circle.setText("");
      else circle.setText(value);
    }
  };
  const error = (data == null ? void 0 : data.status) && (data == null ? void 0 : data.status.error) === true;
  return /* @__PURE__ */ jsxs("div", { className: "rce-mbox-photo", children: [
    /* @__PURE__ */ jsxs(
      "div",
      {
        className: "rce-mbox-photo--img",
        style: __spreadValues({}, (data == null ? void 0 : data.width) && (data == null ? void 0 : data.height) && {
          width: data.width,
          height: data.height
        }),
        children: [
          /* @__PURE__ */ jsx(
            "img",
            {
              src: data == null ? void 0 : data.uri,
              alt: data == null ? void 0 : data.alt,
              onClick: onOpen,
              onKeyDown: console.log,
              onLoad,
              onError: onPhotoError
            }
          ),
          error && /* @__PURE__ */ jsx("div", { className: "rce-mbox-photo--img__block", children: /* @__PURE__ */ jsx("span", { className: "rce-mbox-photo--img__block-item rce-mbox-photo--error", children: /* @__PURE__ */ jsx(FaExclamationTriangle, {}) }) }),
          !error && (data == null ? void 0 : data.status) && !((_a = data == null ? void 0 : data.status) == null ? void 0 : _a.download) && /* @__PURE__ */ jsxs("div", { className: "rce-mbox-photo--img__block", children: [
            !(data == null ? void 0 : data.status.click) && /* @__PURE__ */ jsx(
              "button",
              {
                type: "button",
                onClick: onDownload,
                onKeyDown: console.log,
                className: "rce-mbox-photo--img__block-item rce-mbox-photo--download",
                children: /* @__PURE__ */ jsx(FaCloudDownloadAlt, {})
              }
            ),
            typeof (data == null ? void 0 : data.status.loading) === "number" && (data == null ? void 0 : data.status.loading) !== 0 && /* @__PURE__ */ jsx(
              Circle_default,
              {
                animate: (_b = data == null ? void 0 : data.status.loading) != null ? _b : false,
                progressOptions,
                className: "rce-mbox-photo--img__block-item"
              }
            )
          ] })
        ]
      }
    ),
    text && /* @__PURE__ */ jsx("div", { className: "rce-mbox-text", children: text })
  ] });
};
var PhotoMessage_default = PhotoMessage;

export {
  PhotoMessage_default
};
