import {
  SystemMessage_default
} from "./chunk-A73P7STW.mjs";
import {
  VideoMessage_default
} from "./chunk-ESENO7UF.mjs";
import {
  ReplyMessage_default
} from "./chunk-4UUEB2C6.mjs";
import {
  SpotifyMessage_default
} from "./chunk-VJ3CB7NZ.mjs";
import {
  LeftNotch
} from "./chunk-DUQ2KEPD.mjs";
import {
  RightNotch
} from "./chunk-Y7OA2WO5.mjs";
import {
  MeetingLink_default
} from "./chunk-75NK6TZY.mjs";
import {
  MeetingMessage_default
} from "./chunk-P5UPLDFU.mjs";
import {
  PhotoMessage_default
} from "./chunk-HHE7R5DN.mjs";
import {
  FileMessage_default
} from "./chunk-BU3KSR7U.mjs";
import {
  LocationMessage_default
} from "./chunk-GWI3YT6W.mjs";
import {
  AudioMessage_default
} from "./chunk-B6AAQ2VH.mjs";
import {
  Avatar_default
} from "./chunk-JASX4HQP.mjs";
import {
  __objRest,
  __spreadProps,
  __spreadValues
} from "./chunk-FWCSY2DS.mjs";

// src/MessageBox/MessageBox.tsx
import { useEffect, useRef } from "react";
import { RiShareForwardFill } from "react-icons/ri";
import { IoIosDoneAll } from "react-icons/io";
import {
  MdAccessTime,
  MdCheck,
  MdMessage,
  MdDelete,
  MdBlock,
  MdDoneAll
} from "react-icons/md";
import { TiArrowForward } from "react-icons/ti";
import { format } from "date-fns";
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var MessageBox = (_a) => {
  var _b = _a, {
    focus = false,
    notch = true,
    styles,
    actionButtons
  } = _b, props = __objRest(_b, [
    "focus",
    "notch",
    "styles",
    "actionButtons"
  ]);
  const prevProps = useRef(focus);
  const messageRef = useRef(null);
  const positionCls = classNames("rce-mbox", {
    "rce-mbox-right": props.position === "right"
  });
  const thatAbsoluteTime = !/(text|video|file|meeting|audio)/g.test(props.type || "text") && !(props.type === "location" && props.text);
  const dateText = props.date && (props.dateString || format(props.date, "HH:mm"));
  useEffect(() => {
    var _a2;
    if (prevProps.current !== focus && focus) {
      if (messageRef == null ? void 0 : messageRef.current) {
        (_a2 = messageRef.current) == null ? void 0 : _a2.scrollIntoView({
          behavior: "smooth",
          block: "nearest",
          inline: "start"
        });
        if (props.onMessageFocused instanceof Function)
          props.onMessageFocused(true);
      }
    }
    prevProps.current = focus;
  }, [focus, props.onMessageFocused]);
  return /* @__PURE__ */ jsxs(
    "div",
    {
      ref: messageRef,
      className: classNames("rce-container-mbox", props.className),
      onClick: props.onClick,
      onKeyDown: console.log,
      children: [
        props.renderAddCmp instanceof Function ? props.renderAddCmp() : props.renderAddCmp,
        props.type === "system" ? /* @__PURE__ */ jsx(SystemMessage_default, __spreadProps(__spreadValues({}, props), { focus, notch })) : /* @__PURE__ */ jsxs(
          "div",
          {
            style: styles,
            className: classNames(
              positionCls,
              { "rce-mbox--clear-padding": thatAbsoluteTime },
              { "rce-mbox--clear-notch": !notch },
              { "message-focus": focus }
            ),
            children: [
              /* @__PURE__ */ jsxs("div", { className: "rce-mbox-body", onContextMenu: props.onContextMenu, children: [
                !props.retracted && props.forwarded === true && /* @__PURE__ */ jsx(
                  "div",
                  {
                    className: classNames(
                      "rce-mbox-forward",
                      { "rce-mbox-forward-right": props.position === "left" },
                      { "rce-mbox-forward-left": props.position === "right" }
                    ),
                    onClick: props.onForwardClick,
                    onKeyDown: console.log,
                    children: /* @__PURE__ */ jsx(RiShareForwardFill, {})
                  }
                ),
                !props.retracted && props.replyButton && /* @__PURE__ */ jsx(
                  "div",
                  {
                    className: !props.forwarded ? classNames(
                      "rce-mbox-forward",
                      { "rce-mbox-forward-right": props.position === "left" },
                      { "rce-mbox-forward-left": props.position === "right" }
                    ) : classNames(
                      "rce-mbox-forward",
                      {
                        "rce-mbox-reply-btn-right": props.position === "left"
                      },
                      {
                        "rce-mbox-reply-btn-left": props.position === "right"
                      }
                    ),
                    onClick: props.onReplyClick,
                    onKeyDown: console.log,
                    children: /* @__PURE__ */ jsx(MdMessage, {})
                  }
                ),
                !props.retracted && props.removeButton && /* @__PURE__ */ jsx(
                  "div",
                  {
                    className: props.forwarded ? classNames(
                      "rce-mbox-remove",
                      { "rce-mbox-remove-right": props.position === "left" },
                      { "rce-mbox-remove-left": props.position === "right" }
                    ) : classNames(
                      "rce-mbox-forward",
                      {
                        "rce-mbox-reply-btn-right": props.position === "left"
                      },
                      {
                        "rce-mbox-reply-btn-left": props.position === "right"
                      }
                    ),
                    onClick: props.onRemoveMessageClick,
                    onKeyDown: console.log,
                    children: /* @__PURE__ */ jsx(MdDelete, {})
                  }
                ),
                (props.title || props.avatar) && /* @__PURE__ */ jsxs(
                  "div",
                  {
                    style: __spreadValues({}, props.titleColor && { color: props.titleColor }),
                    onClick: props.onTitleClick,
                    onKeyDown: console.log,
                    className: classNames("rce-mbox-title", {
                      "rce-mbox-title--clear": props.type === "text"
                    }),
                    children: [
                      props.avatar && /* @__PURE__ */ jsx(Avatar_default, { letterItem: props.letterItem, src: props.avatar }),
                      props.title && /* @__PURE__ */ jsx("span", { children: props.title })
                    ]
                  }
                ),
                props.forwardedMessageText ? /* @__PURE__ */ jsx("div", { className: "rce-mbox-forwardedMessage", children: /* @__PURE__ */ jsxs("div", { className: "rce-mbox-forwarded-message", children: [
                  /* @__PURE__ */ jsx(TiArrowForward, { fontSize: 18 }),
                  /* @__PURE__ */ jsxs("i", { style: { margin: "0 3px 1px 0" }, children: [
                    " ",
                    props.forwardedMessageText
                  ] })
                ] }) }) : null,
                !props.forwardedMessageText && props.reply ? /* @__PURE__ */ jsx(ReplyMessage_default, __spreadValues({ onClick: props.onReplyMessageClick }, props)) : null,
                props.type === "text" && /* @__PURE__ */ jsxs(
                  "div",
                  {
                    className: classNames("rce-mbox-text", {
                      "rce-mbox-text-retracted": props.retracted,
                      left: props.position === "left",
                      right: props.position === "right"
                    }),
                    children: [
                      props.retracted && /* @__PURE__ */ jsx(MdBlock, {}),
                      props.text
                    ]
                  }
                ),
                props.type === "location" && /* @__PURE__ */ jsx(LocationMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "photo" && /* @__PURE__ */ jsx(PhotoMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "video" && /* @__PURE__ */ jsx(VideoMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "file" && /* @__PURE__ */ jsx(FileMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "spotify" && /* @__PURE__ */ jsx(SpotifyMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "meeting" && /* @__PURE__ */ jsx(MeetingMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "audio" && /* @__PURE__ */ jsx(AudioMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "meetingLink" && /* @__PURE__ */ jsx(MeetingLink_default, __spreadProps(__spreadValues({}, props), { actionButtons })),
                /* @__PURE__ */ jsxs(
                  "div",
                  {
                    title: props.statusTitle,
                    className: classNames(
                      "rce-mbox-time",
                      { "rce-mbox-time-block": thatAbsoluteTime },
                      { "non-copiable": !props.copiableDate }
                    ),
                    "data-text": props.copiableDate ? void 0 : dateText,
                    children: [
                      props.copiableDate && props.date && (props.dateString || format(props.date, "HH:mm")),
                      props.status && /* @__PURE__ */ jsxs("span", { className: "rce-mbox-status", children: [
                        props.status === "waiting" && /* @__PURE__ */ jsx(MdAccessTime, {}),
                        props.status === "sent" && /* @__PURE__ */ jsx(MdCheck, {}),
                        props.status === "received" && /* @__PURE__ */ jsx(IoIosDoneAll, {}),
                        props.status === "read" && /* @__PURE__ */ jsx(MdDoneAll, { color: "#4FC3F7" })
                      ] })
                    ]
                  }
                )
              ] }),
              notch && (props.position === "right" ? /* @__PURE__ */ jsx(RightNotch, { notchStyle: props.notchStyle, focus }) : /* @__PURE__ */ jsx(LeftNotch, { notchStyle: props.notchStyle, focus }))
            ]
          }
        )
      ]
    }
  );
};
var MessageBox_default = MessageBox;

export {
  MessageBox_default
};
