import {
  __objRest
} from "./chunk-FWCSY2DS.mjs";

// src/Avatar/Avatar.tsx
import { useEffect } from "react";
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var Avatar = (_a) => {
  var _b = _a, {
    type = "default",
    size = "default",
    lazyLoadingImage = void 0
  } = _b, props = __objRest(_b, [
    "type",
    "size",
    "lazyLoadingImage"
  ]);
  const loadedAvatars = [];
  let loading = false;
  let src = props.src;
  let isLazyImage = false;
  useEffect(() => {
    if (lazyLoadingImage) {
      isLazyImage = true;
      if (!isLoaded(src)) {
        src = lazyLoadingImage;
        if (!loading) {
          requestImage(props.src);
        }
      } else {
        isLazyImage = false;
      }
    }
  }, [lazyLoadingImage, src, isLazyImage, loading, props.src]);
  const isLoaded = (src2) => {
    return loadedAvatars.indexOf(src2) !== -1;
  };
  const requestImage = (src2) => {
    loading = true;
    const loaded = () => {
      loadedAvatars.push(src2);
      loading = false;
    };
    const img = document.createElement("img");
    img.src = src2;
    img.onload = loaded;
    img.onerror = loaded;
  };
  const stringToColour = (str) => {
    let hash = 0;
    for (let i = 0; i < str.length; i++) {
      hash = str.charCodeAt(i) + ((hash << 5) - hash);
    }
    let colour = "#";
    for (let i = 0; i < 3; i++) {
      let value = hash >> i * 8 & 255;
      value = value % 150 + 50;
      colour += `00${value.toString(16)}`.substr(-2);
    }
    return colour;
  };
  return /* @__PURE__ */ jsxs(
    "div",
    {
      className: classNames(
        "rce-avatar-container",
        type,
        size,
        props.className
      ),
      children: [
        props.letterItem ? /* @__PURE__ */ jsx(
          "div",
          {
            className: "rce-avatar-letter-background",
            style: { backgroundColor: stringToColour(props.letterItem.id) },
            children: /* @__PURE__ */ jsx("span", { className: "rce-avatar-letter", children: props.letterItem.letter })
          }
        ) : /* @__PURE__ */ jsx(
          "img",
          {
            alt: props.alt,
            src,
            onError: props.onError,
            className: classNames("rce-avatar", {
              "rce-avatar-lazy": isLazyImage
            })
          }
        ),
        props.sideElement
      ]
    }
  );
};
var Avatar_default = Avatar;

export {
  Avatar_default
};
