import {
  Dropdown_default
} from "./chunk-Q4D6QFOJ.mjs";
import {
  Avatar_default
} from "./chunk-JASX4HQP.mjs";
import {
  __objRest
} from "./chunk-FWCSY2DS.mjs";

// src/MeetingMessage/MeetingMessage.tsx
import { useState } from "react";
import { FaCalendar, FaCaretDown, FaCaretRight } from "react-icons/fa";
import { HiOutlineVideoCamera } from "react-icons/hi";
import { IoMdChatboxes } from "react-icons/io";
import { MdMoreHoriz } from "react-icons/md";
import { format } from "date-fns";
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var MeetingMessage = (_a) => {
  var _b = _a, {
    date,
    dateString,
    title,
    subject,
    collapseTitle,
    moreItems,
    participants,
    dataSource,
    onClick,
    onMeetingTitleClick,
    onMeetingVideoLinkClick,
    onMeetingMoreSelect
  } = _b, props = __objRest(_b, [
    "date",
    "dateString",
    "title",
    "subject",
    "collapseTitle",
    "moreItems",
    "participants",
    "dataSource",
    "onClick",
    "onMeetingTitleClick",
    "onMeetingVideoLinkClick",
    "onMeetingMoreSelect"
  ]);
  const [toggle, setToggle] = useState(false);
  const PARTICIPANT_LIMIT = props.participantsLimit || Number.POSITIVE_INFINITY;
  const dateText = dateString ? dateString : date && format(date, "yyyy-MM-dd HH:mm:ss");
  const _onMeetingLinkClick = (item, index, event) => {
    if (onMeetingTitleClick instanceof Function)
      onMeetingTitleClick(item, index, event);
  };
  const _onMeetingVideoLinkClick = (item, index, event) => {
    if (onMeetingVideoLinkClick instanceof Function)
      onMeetingVideoLinkClick(item, index, event);
  };
  const toggleClick = () => {
    setToggle(!toggle);
  };
  return /* @__PURE__ */ jsx("div", { className: "rce-mbox-mtmg", children: /* @__PURE__ */ jsxs("div", { className: "rce-mtmg", children: [
    /* @__PURE__ */ jsx("div", { className: "rce-mtmg-subject", children: subject || "Unknown Meeting" }),
    /* @__PURE__ */ jsxs(
      "div",
      {
        className: "rce-mtmg-body",
        onClick,
        onKeyDown: console.log,
        children: [
          /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-item", children: [
            /* @__PURE__ */ jsx(FaCalendar, {}),
            /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-content", children: [
              /* @__PURE__ */ jsx("span", { className: "rce-mtmg-title", children: title }),
              /* @__PURE__ */ jsx("span", { className: "rce-mtmg-date", children: dateText })
            ] })
          ] }),
          onMeetingMoreSelect && moreItems && moreItems.length > 0 && /* @__PURE__ */ jsx("div", { children: /* @__PURE__ */ jsx(
            Dropdown_default,
            {
              animationType: "bottom",
              animationPosition: "norteast",
              buttonProps: {
                className: "rce-mtmg-right-icon",
                icon: {
                  component: /* @__PURE__ */ jsx(MdMoreHoriz, {}),
                  size: 24
                }
              },
              items: moreItems,
              onSelect: (e) => onMeetingMoreSelect == null ? void 0 : onMeetingMoreSelect(e)
            }
          ) })
        ]
      }
    ),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: "rce-mtmg-body-bottom",
        onClick: toggleClick,
        onKeyDown: console.log,
        children: toggle ? /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-bottom--tptitle", children: [
          /* @__PURE__ */ jsx(FaCaretDown, {}),
          /* @__PURE__ */ jsx("span", { children: collapseTitle })
        ] }) : /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-body-bottom--bttitle", children: [
          /* @__PURE__ */ jsx(FaCaretRight, {}),
          /* @__PURE__ */ jsxs("span", { children: [
            participants == null ? void 0 : participants.slice(0, PARTICIPANT_LIMIT).map((x) => x.title || "Unknow").join(", "),
            participants && PARTICIPANT_LIMIT && participants.length > PARTICIPANT_LIMIT && `, +${participants.length - PARTICIPANT_LIMIT}`
          ] })
        ] })
      }
    ),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: classNames("rce-mtmg-toogleContent", {
          "rce-mtmg-toogleContent--click": toggle
        }),
        children: dataSource == null ? void 0 : dataSource.map((x, i) => {
          var _a2, _b2;
          return /* @__PURE__ */ jsxs("div", { children: [
            !x.event && /* @__PURE__ */ jsxs("div", { className: "rce-mitem", children: [
              /* @__PURE__ */ jsx(
                "div",
                {
                  className: classNames("rce-mitem avatar", {
                    "rce-mitem no-avatar": !x.avatar
                  }),
                  children: x.avatar ? /* @__PURE__ */ jsx(Avatar_default, { src: x.avatar }) : /* @__PURE__ */ jsx(IoMdChatboxes, {})
                }
              ),
              /* @__PURE__ */ jsxs("div", { className: "rce-mitem-body", children: [
                /* @__PURE__ */ jsxs("div", { className: "rce-mitem-body--top", children: [
                  /* @__PURE__ */ jsx(
                    "div",
                    {
                      className: "rce-mitem-body--top-title",
                      onClick: (e) => _onMeetingLinkClick(x, i, e),
                      onKeyDown: console.log,
                      children: x.title
                    }
                  ),
                  /* @__PURE__ */ jsx("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && x.date && format(x.date, "yyyy-MM-dd HH:mm") })
                ] }),
                /* @__PURE__ */ jsx("div", { className: "rce-mitem-body--bottom", children: /* @__PURE__ */ jsx("div", { className: "rce-mitem-body--bottom-title", children: x.message }) })
              ] })
            ] }),
            x.event && /* @__PURE__ */ jsx("div", { className: "rce-mitem-event", children: /* @__PURE__ */ jsxs("div", { className: "rce-mitem-bottom-body", children: [
              /* @__PURE__ */ jsx("div", { className: "rce-mitem-body avatar", children: /* @__PURE__ */ jsx(HiOutlineVideoCamera, {}) }),
              /* @__PURE__ */ jsxs("div", { className: "rce-mitem-bottom-body-top", children: [
                x.event.title,
                /* @__PURE__ */ jsx("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && format(x.date, "yyyy-MM-dd HH:mm") }),
                /* @__PURE__ */ jsx("div", { className: "rce-mitem-avatar-content", children: /* @__PURE__ */ jsxs("div", { className: "rce-mitem-avatar", children: [
                  (_b2 = x.event.avatars) == null ? void 0 : _b2.slice(0, PARTICIPANT_LIMIT).map((x2, i2) => /* @__PURE__ */ jsx(Avatar_default, { src: x2.src }, i2.toString())),
                  x.event.avatars && x.event.avatarsLimit && x.event.avatars.length > x.event.avatarsLimit && /* @__PURE__ */ jsx(
                    "div",
                    {
                      className: "rce-mitem-length rce-mitem-tooltip",
                      tooltip: x.event.avatars.slice(
                        x.event.avatarsLimit,
                        x.event.avatars.length
                      ).map((avatar) => avatar.title).join(",").toString(),
                      children: /* @__PURE__ */ jsx("span", { className: "rce-mitem-tooltip-text", children: `+${x.event.avatars.length - x.event.avatarsLimit}` })
                    }
                  )
                ] }) }),
                x.record && /* @__PURE__ */ jsx("div", { className: "rce-mtmg-call-record", children: /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-call-body", children: [
                  /* @__PURE__ */ jsxs(
                    "div",
                    {
                      onClick: (e) => _onMeetingVideoLinkClick(x, i, e),
                      onKeyDown: console.log,
                      className: "rce-mtmg-call-avatars",
                      children: [
                        /* @__PURE__ */ jsx(
                          Avatar_default,
                          {
                            className: "rce-mtmg-call-avatars",
                            src: x.record.avatar
                          }
                        ),
                        /* @__PURE__ */ jsx("div", { className: "rce-mtmg-record-time", children: x.record.time })
                      ]
                    }
                  ),
                  /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-call-body-title", children: [
                    /* @__PURE__ */ jsx("span", { children: x.record.title }),
                    /* @__PURE__ */ jsx("div", { className: "rce-mtmg-call-body-bottom", children: x.record.savedBy })
                  ] })
                ] }) })
              ] })
            ] }) })
          ] }, (_a2 = x.id) != null ? _a2 : i.toString());
        })
      }
    )
  ] }) });
};
var MeetingMessage_default = MeetingMessage;

export {
  MeetingMessage_default
};
