import {
  MessageBox_default
} from "./chunk-ISHK2MD3.mjs";
import {
  __objRest,
  __spreadProps,
  __spreadValues
} from "./chunk-FWCSY2DS.mjs";

// src/MessageList/MessageList.tsx
import {
  useEffect,
  useRef,
  useState
} from "react";
import classNames from "classnames";
import { FaChevronDown } from "react-icons/fa";
import { jsx, jsxs } from "react/jsx-runtime";
import { createElement } from "react";
var MessageList = (_a) => {
  var _b = _a, {
    reference,
    lockable = false,
    toBottomHeight = 300,
    downButton
  } = _b, props = __objRest(_b, [
    "reference",
    "lockable",
    "toBottomHeight",
    "downButton"
  ]);
  const [scrollBottom, setScrollBottom] = useState(0);
  const [_downButton, setDownButton] = useState(false);
  const prevProps = useRef(props);
  const checkScroll = () => {
    const e = reference;
    if (!e || !e.current) return;
    if (toBottomHeight === "100%" || toBottomHeight && scrollBottom < Number(toBottomHeight)) {
      e.current.scrollTop = e.current.scrollHeight;
    } else {
      if (lockable) {
        e.current.scrollTop = e.current.scrollHeight - e.current.offsetHeight - scrollBottom;
      }
    }
  };
  useEffect(() => {
    var _a2, _b2;
    if (!(reference == null ? void 0 : reference.current)) return;
    if (((_b2 = (_a2 = prevProps.current) == null ? void 0 : _a2.dataSource) == null ? void 0 : _b2.length) !== props.dataSource.length) {
      setScrollBottom(getBottom(reference.current));
      checkScroll();
    }
    prevProps.current = props;
  }, [checkScroll, reference, props]);
  const getBottom = (e) => {
    if (e) {
      return e.scrollHeight - e.scrollTop - e.offsetHeight;
    }
    return 0;
  };
  const onClick = (x, i, e) => {
    if (props.onClick instanceof Function) props.onClick(x, i, e);
  };
  const onOpen = (item, index, event) => {
    if (props.onOpen instanceof Function) props.onOpen(item, index, event);
  };
  const onDownload = (item, index, event) => {
    if (props.onDownload instanceof Function)
      props.onDownload(item, index, event);
  };
  const onPhotoError = (item, index, event) => {
    if (props.onPhotoError instanceof Function)
      props.onPhotoError(item, index, event);
  };
  const onTitleClick = (item, index, event) => {
    if (props.onTitleClick instanceof Function)
      props.onTitleClick(item, index, event);
  };
  const onForwardClick = (item, index, event) => {
    if (props.onForwardClick instanceof Function)
      props.onForwardClick(item, index, event);
  };
  const onReplyClick = (item, index, event) => {
    if (props.onReplyClick instanceof Function)
      props.onReplyClick(item, index, event);
  };
  const onReplyMessageClick = (item, index, event) => {
    if (props.onReplyMessageClick instanceof Function)
      props.onReplyMessageClick(item, index, event);
  };
  const onRemoveMessageClick = (item, index, event) => {
    if (props.onRemoveMessageClick instanceof Function)
      props.onRemoveMessageClick(item, index, event);
  };
  const onContextMenu = (item, index, event) => {
    if (props.onContextMenu instanceof Function)
      props.onContextMenu(item, index, event);
  };
  const onMessageFocused = (item, index, isFocused) => {
    if (props.onMessageFocused instanceof Function)
      props.onMessageFocused(item, index, isFocused);
  };
  const onMeetingMessageClick = (item, index, event) => {
    if (props.onMeetingMessageClick instanceof Function)
      props.onMeetingMessageClick(item, index, event);
  };
  const onScroll = (e) => {
    const element = e == null ? void 0 : e.currentTarget;
    const bottom = getBottom(element);
    setScrollBottom(bottom);
    if (toBottomHeight === "100%" || toBottomHeight && bottom > Number(toBottomHeight)) {
      if (!_downButton) {
        setDownButton(true);
        setScrollBottom(bottom);
      }
    } else {
      if (_downButton) {
        setDownButton(false);
        setScrollBottom(bottom);
      }
    }
    if (props.onScroll instanceof Function) {
      props.onScroll(e);
    }
  };
  const toBottom = (e) => {
    if (!(reference == null ? void 0 : reference.current)) return;
    const el = reference.current;
    el.scrollTop = el.scrollHeight;
    if (props.onDownButtonClick instanceof Function) props.onDownButtonClick(e);
  };
  const onMeetingMoreSelect = (item, i, e) => {
    if (props.onMeetingMoreSelect instanceof Function)
      props.onMeetingMoreSelect(item, i, e);
  };
  const onMeetingLinkClick = (item, i, e) => {
    if (props.onMeetingLinkClick instanceof Function)
      props.onMeetingLinkClick(item, i, e);
  };
  return /* @__PURE__ */ jsxs(
    "div",
    __spreadProps(__spreadValues({
      className: classNames(["rce-container-mlist", props.className])
    }, props.customProps), {
      children: [
        !!props.children && props.isShowChild && props.children,
        /* @__PURE__ */ jsx(
          "div",
          {
            ref: reference,
            onScroll: (e) => onScroll(e),
            className: "rce-mlist",
            children: props.dataSource ? props.dataSource.map((x, i) => /* @__PURE__ */ createElement(
              MessageBox_default,
              __spreadProps(__spreadValues({}, x), {
                key: i.toString(),
                onOpen: (e) => onOpen(x, i, e),
                onPhotoError: (e) => onPhotoError(x, i, e),
                onDownload: (e) => onDownload(x, i, e),
                onTitleClick: props.onTitleClick && ((e) => onTitleClick(x, i, e)),
                onForwardClick: (e) => onForwardClick(x, i, e),
                onReplyClick: (e) => onReplyClick(x, i, e),
                onReplyMessageClick: (e) => onReplyMessageClick(x, i, e),
                onRemoveMessageClick: (e) => onRemoveMessageClick(x, i, e),
                onClick: (e) => onClick(x, i, e),
                onContextMenu: (e) => onContextMenu(x, i, e),
                onMeetingMoreSelect: (e) => onMeetingMoreSelect(x, i, e),
                onMessageFocused: (r) => onMessageFocused(x, i, r),
                onMeetingMessageClick: (e) => onMeetingMessageClick(x, i, e),
                onMeetingTitleClick: props.onMeetingTitleClick,
                onMeetingVideoLinkClick: props.onMeetingVideoLinkClick,
                onMeetingLinkClick: (e) => onMeetingLinkClick(x, i, e),
                actionButtons: props.actionButtons,
                styles: props.messageBoxStyles,
                notchStyle: props.notchStyle
              })
            )) : null
          }
        ),
        downButton === true && _downButton && toBottomHeight !== "100%" && /* @__PURE__ */ jsxs(
          "div",
          {
            className: "rce-mlist-down-button",
            onClick: (e) => toBottom(e),
            onKeyDown: console.log,
            children: [
              /* @__PURE__ */ jsx(FaChevronDown, {}),
              props.downButtonBadge !== void 0 ? /* @__PURE__ */ jsx("span", { className: "rce-mlist-down-button--badge", children: props.downButtonBadge.toString() }) : null
            ]
          }
        )
      ]
    })
  );
};
var MessageList_default = MessageList;

export {
  MessageList_default
};
