// src/Circle/Circle.tsx
import { useEffect, useMemo, useCallback } from "react";
import { Circle } from "progressbar.js";
import { jsx } from "react/jsx-runtime";
var wrapper;
var ProgressCircle = ({
  animate,
  progressOptions,
  className,
  progress = 0
}) => {
  const animateProgress = useMemo(() => progress, [progress]);
  const bar = useMemo(() => {
    wrapper = document.createElement("div");
    return new Circle(wrapper, progressOptions);
  }, [progressOptions]);
  const node = useCallback((node2) => {
    if (node2) {
      node2.appendChild(wrapper);
    }
  }, []);
  useEffect(() => {
    if (animate) {
      bar.animate(animateProgress);
    }
  }, [animate, animateProgress, bar]);
  return /* @__PURE__ */ jsx("div", { className, ref: node });
};
var Circle_default = ProgressCircle;

export {
  Circle_default
};
