"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  AudioMessage: () => AudioMessage_default,
  Avatar: () => Avatar_default,
  Button: () => Button_default,
  ChatItem: () => ChatItem_default,
  ChatList: () => ChatList_default,
  Circle: () => Circle_default,
  Dropdown: () => Dropdown_default,
  FileMessage: () => FileMessage_default,
  Input: () => Input_default,
  LocationMessage: () => LocationMessage_default,
  MeetingItem: () => MeetingItem_default,
  MeetingLink: () => MeetingLink_default,
  MeetingList: () => MeetingList_default,
  MeetingMessage: () => MeetingMessage_default,
  MessageBox: () => MessageBox_default,
  MessageList: () => MessageList_default,
  Navbar: () => Navbar_default,
  PhotoMessage: () => PhotoMessage_default,
  Popup: () => Popup_default,
  ReplyMessage: () => ReplyMessage_default,
  SideBar: () => SideBar_default,
  SpotifyMessage: () => SpotifyMessage_default,
  SystemMessage: () => SystemMessage_default,
  VideoMessage: () => VideoMessage_default
});
module.exports = __toCommonJS(src_exports);

// src/MessageBox/MessageBox.tsx
var import_react5 = require("react");

// src/PhotoMessage/PhotoMessage.tsx
var import_fa = require("react-icons/fa");

// src/Circle/Circle.tsx
var import_react = require("react");
var import_progressbar = require("progressbar.js");
var import_jsx_runtime = require("react/jsx-runtime");
var wrapper;
var ProgressCircle = ({
  animate,
  progressOptions,
  className,
  progress = 0
}) => {
  const animateProgress = (0, import_react.useMemo)(() => progress, [progress]);
  const bar = (0, import_react.useMemo)(() => {
    wrapper = document.createElement("div");
    return new import_progressbar.Circle(wrapper, progressOptions);
  }, [progressOptions]);
  const node = (0, import_react.useCallback)((node2) => {
    if (node2) {
      node2.appendChild(wrapper);
    }
  }, []);
  (0, import_react.useEffect)(() => {
    if (animate) {
      bar.animate(animateProgress);
    }
  }, [animate, animateProgress, bar]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className, ref: node });
};
var Circle_default = ProgressCircle;

// src/PhotoMessage/PhotoMessage.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var PhotoMessage = ({
  text,
  data,
  onDownload,
  onLoad,
  onOpen,
  onPhotoError
}) => {
  var _a, _b;
  const progressOptions = {
    strokeWidth: 2.3,
    color: "#efe",
    trailColor: "#aaa",
    trailWidth: 1,
    step: (state, circle) => {
      var _a2, _b2;
      circle.path.setAttribute("trail", (_a2 = state == null ? void 0 : state.state) == null ? void 0 : _a2.color);
      circle.path.setAttribute("trailwidth-width", (_b2 = state == null ? void 0 : state.state) == null ? void 0 : _b2.width);
      const value = Math.round(circle.value() * 100);
      if (value === 0) circle.setText("");
      else circle.setText(value);
    }
  };
  const error = (data == null ? void 0 : data.status) && (data == null ? void 0 : data.status.error) === true;
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mbox-photo", children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
      "div",
      {
        className: "rce-mbox-photo--img",
        style: __spreadValues({}, (data == null ? void 0 : data.width) && (data == null ? void 0 : data.height) && {
          width: data.width,
          height: data.height
        }),
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
            "img",
            {
              src: data == null ? void 0 : data.uri,
              alt: data == null ? void 0 : data.alt,
              onClick: onOpen,
              onKeyDown: console.log,
              onLoad,
              onError: onPhotoError
            }
          ),
          error && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-photo--img__block", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { className: "rce-mbox-photo--img__block-item rce-mbox-photo--error", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaExclamationTriangle, {}) }) }),
          !error && (data == null ? void 0 : data.status) && !((_a = data == null ? void 0 : data.status) == null ? void 0 : _a.download) && /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mbox-photo--img__block", children: [
            !(data == null ? void 0 : data.status.click) && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
              "button",
              {
                type: "button",
                onClick: onDownload,
                onKeyDown: console.log,
                className: "rce-mbox-photo--img__block-item rce-mbox-photo--download",
                children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaCloudDownloadAlt, {})
              }
            ),
            typeof (data == null ? void 0 : data.status.loading) === "number" && (data == null ? void 0 : data.status.loading) !== 0 && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
              Circle_default,
              {
                animate: (_b = data == null ? void 0 : data.status.loading) != null ? _b : false,
                progressOptions,
                className: "rce-mbox-photo--img__block-item"
              }
            )
          ] })
        ]
      }
    ),
    text && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-text", children: text })
  ] });
};
var PhotoMessage_default = PhotoMessage;

// src/FileMessage/FileMessage.tsx
var import_fa2 = require("react-icons/fa");
var import_jsx_runtime3 = require("react/jsx-runtime");
var FileMessage = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j;
  const progressOptions = {
    strokeWidth: 5,
    color: "#333",
    trailColor: "#aaa",
    trailWidth: 5,
    step: (state, circle) => {
      circle.path.setAttribute("trail", state.color);
      circle.path.setAttribute("trailwidth-width", state.width);
      const value = Math.round(circle.value() * 100);
      if (value === 0) circle.setText("");
      else circle.setText(value);
    }
  };
  const error = ((_a = props == null ? void 0 : props.data) == null ? void 0 : _a.status) && ((_b = props == null ? void 0 : props.data) == null ? void 0 : _b.status.error) === true;
  const onClick = (e) => {
    var _a2, _b2, _c2;
    if (!((_a2 = props == null ? void 0 : props.data) == null ? void 0 : _a2.status)) return;
    if (!((_b2 = props == null ? void 0 : props.data) == null ? void 0 : _b2.status.download) && props.onDownload instanceof Function)
      props.onDownload(e);
    else if (((_c2 = props == null ? void 0 : props.data) == null ? void 0 : _c2.status.download) && props.onOpen instanceof Function)
      props.onOpen(e);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { className: "rce-mbox-file", children: /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("button", { onClick, children: [
    /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("div", { className: "rce-mbox-file--icon", children: [
      /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_fa2.FaFile, { color: "#aaa" }),
      ((_c = props == null ? void 0 : props.data) == null ? void 0 : _c.size) ? /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { className: "rce-mbox-file--size", children: props == null ? void 0 : props.data.size }) : null
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { className: "rce-mbox-file--text", children: props.text }),
    /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("div", { className: "rce-mbox-file--buttons", children: [
      error && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("span", { className: "rce-error-button", children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_fa2.FaExclamationTriangle, { color: "#ff3d3d" }) }),
      !error && ((_d = props == null ? void 0 : props.data) == null ? void 0 : _d.status) && !((_e = props == null ? void 0 : props.data) == null ? void 0 : _e.status.download) && !((_f = props == null ? void 0 : props.data) == null ? void 0 : _f.status.click) && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_fa2.FaCloudDownloadAlt, { color: "#aaa" }),
      !error && ((_g = props == null ? void 0 : props.data) == null ? void 0 : _g.status) && typeof ((_h = props == null ? void 0 : props.data) == null ? void 0 : _h.status.loading) === "number" && ((_i = props == null ? void 0 : props.data) == null ? void 0 : _i.status.loading) !== 0 && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
        Circle_default,
        {
          animate: !!((_j = props == null ? void 0 : props.data) == null ? void 0 : _j.status.loading),
          className: "rce-mbox-file--loading",
          progressOptions
        }
      )
    ] })
  ] }) });
};
var FileMessage_default = FileMessage;

// src/SystemMessage/SystemMessage.tsx
var import_classnames = __toESM(require("classnames"));
var import_jsx_runtime4 = require("react/jsx-runtime");
var SystemMessage = (props) => {
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: (0, import_classnames.default)("rce-container-smsg", props.className), children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-smsg", children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-smsg-text", children: props.text }) }) });
};
var SystemMessage_default = SystemMessage;

// src/LocationMessage/LocationMessage.tsx
var import_classnames2 = __toESM(require("classnames"));

// src/constants.ts
var STATIC_URL = "https://maps.googleapis.com/maps/api/staticmap?markers=color:MARKER_COLOR|LATITUDE,LONGITUDE&zoom=ZOOM&size=270x200&scale=2&key=KEY";
var MAP_URL = "https://www.google.com/maps/search/?api=1&query=LATITUDE,LONGITUDE&zoom=ZOOM";

// src/LocationMessage/LocationMessage.tsx
var import_jsx_runtime5 = require("react/jsx-runtime");
var LocationMessage = (_a) => {
  var _b = _a, {
    markerColor = "red",
    target = "_blank",
    zoom = "14"
  } = _b, props = __objRest(_b, [
    "markerColor",
    "target",
    "zoom"
  ]);
  var _a2, _b2;
  const buildURL = (url) => {
    var _a3, _b3, _c, _d, _e;
    return url.replace(/LATITUDE/g, (_b3 = (_a3 = props == null ? void 0 : props.data) == null ? void 0 : _a3.latitude.toString()) != null ? _b3 : "0").replace(/LONGITUDE/g, (_d = (_c = props == null ? void 0 : props.data) == null ? void 0 : _c.longitude.toString()) != null ? _d : "0").replace("MARKER_COLOR", markerColor).replace("ZOOM", zoom).replace("KEY", (_e = props == null ? void 0 : props.apiKey) != null ? _e : "");
  };
  const className = () => {
    let _className = (0, import_classnames2.default)("rce-mbox-location", props.className);
    if (props.text) {
      _className = (0, import_classnames2.default)(_className, "rce-mbox-location-has-text");
    }
    return _className;
  };
  return /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-container-lmsg", children: [
    /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
      "a",
      {
        onClick: props.onOpen,
        target,
        href: props.href || props.src || buildURL(((_a2 = props.data) == null ? void 0 : _a2.mapURL) || MAP_URL),
        className: className(),
        children: /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
          "img",
          {
            alt: props.alt,
            onError: props.onError,
            className: "rce-mbox-location-img",
            src: props.src || buildURL(((_b2 = props.data) == null ? void 0 : _b2.staticURL) || STATIC_URL)
          }
        )
      }
    ),
    props.text && /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mbox-text rce-mbox-location-text", children: props.text })
  ] });
};
var LocationMessage_default = LocationMessage;

// src/SpotifyMessage/SpotifyMessage.tsx
var import_jsx_runtime6 = require("react/jsx-runtime");
var SpotifyMessage = (_a) => {
  var _b = _a, {
    width = 300,
    height = 380
  } = _b, props = __objRest(_b, [
    "width",
    "height"
  ]);
  const toUrl = () => {
    const formBody = [];
    for (const property in props) {
      const encodedKey = encodeURIComponent(property);
      const encodedValue = encodeURIComponent(props[property]);
      formBody.push(`${encodedKey}=${encodedValue}`);
    }
    return formBody.join("&");
  };
  if (!props.uri) return null;
  return /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("div", { className: "rce-mbox-spotify", children: /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
    "iframe",
    {
      title: "Spotify",
      src: `https://open.spotify.com/embed?${toUrl()}`,
      width,
      height
    }
  ) });
};
var SpotifyMessage_default = SpotifyMessage;

// src/ReplyMessage/ReplyMessage.tsx
var import_classnames3 = __toESM(require("classnames"));
var import_jsx_runtime7 = require("react/jsx-runtime");
var ReplyMessage = (_a) => {
  var _b = _a, { onClick } = _b, props = __objRest(_b, ["onClick"]);
  return /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)(
    "div",
    {
      className: (0, import_classnames3.default)("rce-mbox-reply", {
        "rce-mbox-reply-border": !!props.titleColor
      }),
      style: __spreadValues({}, props.titleColor && { borderColor: props.titleColor }),
      onClick,
      onKeyDown: console.log,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)("div", { className: "rce-mbox-reply-left", children: [
          /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(
            "div",
            {
              style: __spreadValues({}, props.titleColor && { color: props.titleColor }),
              className: "rce-mbox-reply-owner",
              children: props.title || "Unknown"
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("div", { className: "rce-mbox-reply-message", children: props.message || "..." })
        ] }),
        props.photoURL && /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("div", { className: "rce-mbox-reply-right", children: /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("img", { src: props.photoURL, alt: "" }) })
      ]
    }
  );
};
var ReplyMessage_default = ReplyMessage;

// src/MeetingMessage/MeetingMessage.tsx
var import_react4 = require("react");
var import_fa3 = require("react-icons/fa");
var import_hi = require("react-icons/hi");
var import_io = require("react-icons/io");
var import_md = require("react-icons/md");
var import_date_fns = require("date-fns");

// src/Avatar/Avatar.tsx
var import_react2 = require("react");
var import_classnames4 = __toESM(require("classnames"));
var import_jsx_runtime8 = require("react/jsx-runtime");
var Avatar = (_a) => {
  var _b = _a, {
    type = "default",
    size = "default",
    lazyLoadingImage = void 0
  } = _b, props = __objRest(_b, [
    "type",
    "size",
    "lazyLoadingImage"
  ]);
  const loadedAvatars = [];
  let loading = false;
  let src = props.src;
  let isLazyImage = false;
  (0, import_react2.useEffect)(() => {
    if (lazyLoadingImage) {
      isLazyImage = true;
      if (!isLoaded(src)) {
        src = lazyLoadingImage;
        if (!loading) {
          requestImage(props.src);
        }
      } else {
        isLazyImage = false;
      }
    }
  }, [lazyLoadingImage, src, isLazyImage, loading, props.src]);
  const isLoaded = (src2) => {
    return loadedAvatars.indexOf(src2) !== -1;
  };
  const requestImage = (src2) => {
    loading = true;
    const loaded = () => {
      loadedAvatars.push(src2);
      loading = false;
    };
    const img = document.createElement("img");
    img.src = src2;
    img.onload = loaded;
    img.onerror = loaded;
  };
  const stringToColour = (str) => {
    let hash = 0;
    for (let i = 0; i < str.length; i++) {
      hash = str.charCodeAt(i) + ((hash << 5) - hash);
    }
    let colour = "#";
    for (let i = 0; i < 3; i++) {
      let value = hash >> i * 8 & 255;
      value = value % 150 + 50;
      colour += `00${value.toString(16)}`.substr(-2);
    }
    return colour;
  };
  return /* @__PURE__ */ (0, import_jsx_runtime8.jsxs)(
    "div",
    {
      className: (0, import_classnames4.default)(
        "rce-avatar-container",
        type,
        size,
        props.className
      ),
      children: [
        props.letterItem ? /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(
          "div",
          {
            className: "rce-avatar-letter-background",
            style: { backgroundColor: stringToColour(props.letterItem.id) },
            children: /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("span", { className: "rce-avatar-letter", children: props.letterItem.letter })
          }
        ) : /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(
          "img",
          {
            alt: props.alt,
            src,
            onError: props.onError,
            className: (0, import_classnames4.default)("rce-avatar", {
              "rce-avatar-lazy": isLazyImage
            })
          }
        ),
        props.sideElement
      ]
    }
  );
};
var Avatar_default = Avatar;

// src/Dropdown/Dropdown.tsx
var import_react3 = require("react");
var import_classnames6 = __toESM(require("classnames"));

// src/Button/Button.tsx
var import_classnames5 = __toESM(require("classnames"));
var import_jsx_runtime9 = require("react/jsx-runtime");
var Button = (_a) => {
  var _b = _a, {
    disabled = false,
    backgroundColor = "#3979aa",
    color = "white"
  } = _b, props = __objRest(_b, [
    "disabled",
    "backgroundColor",
    "color"
  ]);
  var _a2, _b2;
  return /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(
    "button",
    {
      type: (_a2 = props == null ? void 0 : props.type) != null ? _a2 : "button",
      ref: props.buttonRef,
      title: props.title,
      className: (0, import_classnames5.default)("rce-button", props.type, props.className),
      style: {
        backgroundColor,
        color,
        borderColor: backgroundColor
      },
      disabled,
      onClick: props.onClick,
      children: props.icon ? /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)("span", { className: "rce-button-icon--container", children: [
        (props.icon.float === "right" || !props.icon.float) && /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("span", { children: props.text }),
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(
          "span",
          {
            style: {
              float: (_b2 = props.icon.float) != null ? _b2 : "inherit",
              fontSize: props.icon.size || 12
            },
            className: "rce-button-icon",
            children: props.icon.component
          }
        ),
        props.icon.float === "left" && /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("span", { children: props.text })
      ] }) : /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("span", { children: props.text })
    }
  );
};
var Button_default = Button;

// src/Dropdown/Dropdown.tsx
var import_jsx_runtime10 = require("react/jsx-runtime");
var Dropdown = (_a) => {
  var _b = _a, {
    animationPosition = "nortwest",
    animationType = "default"
  } = _b, props = __objRest(_b, [
    "animationPosition",
    "animationType"
  ]);
  var _a2;
  const [show, setShow] = (0, import_react3.useState)(void 0);
  const onBlur = () => {
    if (show === true) setShow(false);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime10.jsxs)(
    "div",
    {
      className: (0, import_classnames6.default)("rce-dropdown-container", props.className),
      onBlur,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(Button_default, __spreadProps(__spreadValues({}, props.buttonProps), { onClick: () => setShow(!show) })),
        /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(
          "div",
          {
            className: (0, import_classnames6.default)(
              "rce-dropdown",
              animationType,
              `rce-dropdown-open__${animationPosition}`,
              { "dropdown-hide": show === false },
              { "dropdown-show": show === true }
            ),
            children: /* @__PURE__ */ (0, import_jsx_runtime10.jsxs)("ul", { children: [
              props.title && /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("span", { className: "rce-dropdown-title", children: props.title }),
              (_a2 = props.items) == null ? void 0 : _a2.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(
                "li",
                {
                  onMouseDown: (e) => props.onSelect instanceof Function ? props.onSelect(e, i) : void 0,
                  children: typeof x !== "string" ? x.icon ? /* @__PURE__ */ (0, import_jsx_runtime10.jsxs)("span", { className: "rce-button-icon--container", children: [
                    (x.icon.float === "right" || !x.icon.float) && /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("button", { type: "button", className: "rce-button-link", children: x.text }),
                    /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(
                      "span",
                      {
                        style: {
                          float: x.icon.float,
                          color: x.icon.color,
                          fontSize: x.icon.size || 12
                        },
                        className: (0, import_classnames6.default)(
                          "rce-button-icon",
                          x.icon.className
                        ),
                        children: x.icon.component
                      }
                    ),
                    x.icon.float === "left" && /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("button", { type: "button", className: "rce-button-link", children: x.text })
                  ] }) : /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("button", { type: "button", className: "rce-button-link", children: x.text }) : /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("button", { type: "button", className: "rce-button-link", children: x })
                },
                i.toString()
              ))
            ] })
          }
        )
      ]
    }
  );
};
var Dropdown_default = Dropdown;

// src/MeetingMessage/MeetingMessage.tsx
var import_classnames7 = __toESM(require("classnames"));
var import_jsx_runtime11 = require("react/jsx-runtime");
var MeetingMessage = (_a) => {
  var _b = _a, {
    date,
    dateString,
    title,
    subject,
    collapseTitle,
    moreItems,
    participants,
    dataSource,
    onClick,
    onMeetingTitleClick,
    onMeetingVideoLinkClick,
    onMeetingMoreSelect
  } = _b, props = __objRest(_b, [
    "date",
    "dateString",
    "title",
    "subject",
    "collapseTitle",
    "moreItems",
    "participants",
    "dataSource",
    "onClick",
    "onMeetingTitleClick",
    "onMeetingVideoLinkClick",
    "onMeetingMoreSelect"
  ]);
  const [toggle, setToggle] = (0, import_react4.useState)(false);
  const PARTICIPANT_LIMIT = props.participantsLimit || Number.POSITIVE_INFINITY;
  const dateText = dateString ? dateString : date && (0, import_date_fns.format)(date, "yyyy-MM-dd HH:mm:ss");
  const _onMeetingLinkClick = (item, index, event) => {
    if (onMeetingTitleClick instanceof Function)
      onMeetingTitleClick(item, index, event);
  };
  const _onMeetingVideoLinkClick = (item, index, event) => {
    if (onMeetingVideoLinkClick instanceof Function)
      onMeetingVideoLinkClick(item, index, event);
  };
  const toggleClick = () => {
    setToggle(!toggle);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mbox-mtmg", children: /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mtmg", children: [
    /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mtmg-subject", children: subject || "Unknown Meeting" }),
    /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)(
      "div",
      {
        className: "rce-mtmg-body",
        onClick,
        onKeyDown: console.log,
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mtmg-item", children: [
            /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_fa3.FaCalendar, {}),
            /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mtmg-content", children: [
              /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("span", { className: "rce-mtmg-title", children: title }),
              /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("span", { className: "rce-mtmg-date", children: dateText })
            ] })
          ] }),
          onMeetingMoreSelect && moreItems && moreItems.length > 0 && /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { children: /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(
            Dropdown_default,
            {
              animationType: "bottom",
              animationPosition: "norteast",
              buttonProps: {
                className: "rce-mtmg-right-icon",
                icon: {
                  component: /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_md.MdMoreHoriz, {}),
                  size: 24
                }
              },
              items: moreItems,
              onSelect: (e) => onMeetingMoreSelect == null ? void 0 : onMeetingMoreSelect(e)
            }
          ) })
        ]
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(
      "div",
      {
        className: "rce-mtmg-body-bottom",
        onClick: toggleClick,
        onKeyDown: console.log,
        children: toggle ? /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mtmg-bottom--tptitle", children: [
          /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_fa3.FaCaretDown, {}),
          /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("span", { children: collapseTitle })
        ] }) : /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mtmg-body-bottom--bttitle", children: [
          /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_fa3.FaCaretRight, {}),
          /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("span", { children: [
            participants == null ? void 0 : participants.slice(0, PARTICIPANT_LIMIT).map((x) => x.title || "Unknow").join(", "),
            participants && PARTICIPANT_LIMIT && participants.length > PARTICIPANT_LIMIT && `, +${participants.length - PARTICIPANT_LIMIT}`
          ] })
        ] })
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(
      "div",
      {
        className: (0, import_classnames7.default)("rce-mtmg-toogleContent", {
          "rce-mtmg-toogleContent--click": toggle
        }),
        children: dataSource == null ? void 0 : dataSource.map((x, i) => {
          var _a2, _b2;
          return /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { children: [
            !x.event && /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mitem", children: [
              /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(
                "div",
                {
                  className: (0, import_classnames7.default)("rce-mitem avatar", {
                    "rce-mitem no-avatar": !x.avatar
                  }),
                  children: x.avatar ? /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(Avatar_default, { src: x.avatar }) : /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_io.IoMdChatboxes, {})
                }
              ),
              /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mitem-body", children: [
                /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mitem-body--top", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(
                    "div",
                    {
                      className: "rce-mitem-body--top-title",
                      onClick: (e) => _onMeetingLinkClick(x, i, e),
                      onKeyDown: console.log,
                      children: x.title
                    }
                  ),
                  /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && x.date && (0, import_date_fns.format)(x.date, "yyyy-MM-dd HH:mm") })
                ] }),
                /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mitem-body--bottom", children: /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mitem-body--bottom-title", children: x.message }) })
              ] })
            ] }),
            x.event && /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mitem-event", children: /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mitem-bottom-body", children: [
              /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mitem-body avatar", children: /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_hi.HiOutlineVideoCamera, {}) }),
              /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mitem-bottom-body-top", children: [
                x.event.title,
                /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && (0, import_date_fns.format)(x.date, "yyyy-MM-dd HH:mm") }),
                /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mitem-avatar-content", children: /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mitem-avatar", children: [
                  (_b2 = x.event.avatars) == null ? void 0 : _b2.slice(0, PARTICIPANT_LIMIT).map((x2, i2) => /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(Avatar_default, { src: x2.src }, i2.toString())),
                  x.event.avatars && x.event.avatarsLimit && x.event.avatars.length > x.event.avatarsLimit && /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(
                    "div",
                    {
                      className: "rce-mitem-length rce-mitem-tooltip",
                      tooltip: x.event.avatars.slice(
                        x.event.avatarsLimit,
                        x.event.avatars.length
                      ).map((avatar) => avatar.title).join(",").toString(),
                      children: /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("span", { className: "rce-mitem-tooltip-text", children: `+${x.event.avatars.length - x.event.avatarsLimit}` })
                    }
                  )
                ] }) }),
                x.record && /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mtmg-call-record", children: /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mtmg-call-body", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)(
                    "div",
                    {
                      onClick: (e) => _onMeetingVideoLinkClick(x, i, e),
                      onKeyDown: console.log,
                      className: "rce-mtmg-call-avatars",
                      children: [
                        /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(
                          Avatar_default,
                          {
                            className: "rce-mtmg-call-avatars",
                            src: x.record.avatar
                          }
                        ),
                        /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mtmg-record-time", children: x.record.time })
                      ]
                    }
                  ),
                  /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("div", { className: "rce-mtmg-call-body-title", children: [
                    /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("span", { children: x.record.title }),
                    /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { className: "rce-mtmg-call-body-bottom", children: x.record.savedBy })
                  ] })
                ] }) })
              ] })
            ] }) })
          ] }, (_a2 = x.id) != null ? _a2 : i.toString());
        })
      }
    )
  ] }) });
};
var MeetingMessage_default = MeetingMessage;

// src/VideoMessage/VideoMessage.tsx
var import_fa4 = require("react-icons/fa");
var import_classnames8 = __toESM(require("classnames"));
var import_jsx_runtime12 = require("react/jsx-runtime");
var VideoMessage = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i;
  const progressOptions = {
    strokeWidth: 2.3,
    color: "#efe",
    trailColor: "#aaa",
    trailWidth: 1,
    step: (data, circle) => {
      var _a2, _b2;
      circle.path.setAttribute("trail", ((_a2 = data == null ? void 0 : data.state) == null ? void 0 : _a2.color) || "");
      circle.path.setAttribute("trailwidth-width", ((_b2 = data == null ? void 0 : data.state) == null ? void 0 : _b2.width) || "");
      const value = Math.round((circle == null ? void 0 : circle.value()) * 100);
      if (value === 0) circle == null ? void 0 : circle.setText("");
      else circle == null ? void 0 : circle.setText(value);
    }
  };
  const error = ((_a = props == null ? void 0 : props.data) == null ? void 0 : _a.status) && ((_b = props == null ? void 0 : props.data) == null ? void 0 : _b.status.error) === true;
  const downloaded = (_d = (_c = props == null ? void 0 : props.data) == null ? void 0 : _c.status) == null ? void 0 : _d.download;
  return /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)(
    "div",
    {
      className: (0, import_classnames8.default)("rce-mbox-video", {
        "padding-time": !(props == null ? void 0 : props.text)
      }),
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)(
          "div",
          {
            className: "rce-mbox-video--video",
            style: __spreadValues({}, ((_e = props == null ? void 0 : props.data) == null ? void 0 : _e.width) && ((_f = props == null ? void 0 : props.data) == null ? void 0 : _f.height) && {
              width: props.data.width,
              height: props.data.height
            }),
            children: [
              !downloaded && /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
                "img",
                {
                  src: (_g = props == null ? void 0 : props.data) == null ? void 0 : _g.uri,
                  alt: (_h = props == null ? void 0 : props.data) == null ? void 0 : _h.alt,
                  onClick: props.onOpen,
                  onKeyDown: console.log,
                  onLoad: props.onLoad,
                  onError: props.onPhotoError
                }
              ),
              downloaded && /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("video", { controls: true, controlsList: props.controlsList, children: [
                /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("source", { src: props == null ? void 0 : props.data.videoURL, type: "video/mp4" }),
                "Your browser does not support HTML video."
              ] }),
              error && /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mbox-video--video__block", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("span", { className: "rce-mbox-video--video__block-item rce-mbox-video--error", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_fa4.FaExclamationTriangle, {}) }) }),
              !error && ((_i = props == null ? void 0 : props.data) == null ? void 0 : _i.status) && !downloaded && /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mbox-video--video__block", children: [
                !props.data.status.click && /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
                  "button",
                  {
                    type: "button",
                    onClick: props.onDownload,
                    className: "rce-mbox-video--video__block-item rce-mbox-video--download",
                    children: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_fa4.FaCloudDownloadAlt, {})
                  }
                ),
                typeof props.data.status.loading === "number" && props.data.status.loading !== 0 && /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
                  Circle_default,
                  {
                    animate: props.data.status.loading,
                    className: "rce-mbox-video--video__block-item",
                    progressOptions
                  }
                )
              ] })
            ]
          }
        ),
        (props == null ? void 0 : props.text) && /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mbox-text", children: props.text })
      ]
    }
  );
};
var VideoMessage_default = VideoMessage;

// src/AudioMessage/AudioMessage.tsx
var import_jsx_runtime13 = require("react/jsx-runtime");
var AudioMessage = (props) => {
  var _a, _b, _c, _d;
  const controlsList = (_b = (_a = props.data) == null ? void 0 : _a.controlsList) != null ? _b : "nodownload";
  return /* @__PURE__ */ (0, import_jsx_runtime13.jsxs)("div", { className: "rce-mbox-audio", style: props.customStyle, children: [
    /* @__PURE__ */ (0, import_jsx_runtime13.jsxs)("audio", __spreadProps(__spreadValues({}, props.audioProps), { controls: true, controlsList, children: [
      /* @__PURE__ */ (0, import_jsx_runtime13.jsx)(
        "source",
        {
          src: props.data.audioURL,
          type: (_d = (_c = props.data) == null ? void 0 : _c.audioType) != null ? _d : "audio/mp3"
        }
      ),
      "Your browser does not support the audio element."
    ] })),
    props.text && /* @__PURE__ */ (0, import_jsx_runtime13.jsx)("div", { className: "rce-mbox-text", children: props.text })
  ] });
};
var AudioMessage_default = AudioMessage;

// src/MeetingLink/MeetingLink.tsx
var import_jsx_runtime14 = require("react/jsx-runtime");
var MeetingLink = (props) => {
  var _a;
  return /* @__PURE__ */ (0, import_jsx_runtime14.jsx)("div", { className: "rce-mtlink", children: /* @__PURE__ */ (0, import_jsx_runtime14.jsxs)("div", { className: "rce-mtlink-content", children: [
    /* @__PURE__ */ (0, import_jsx_runtime14.jsx)("div", { className: "rce-mtlink-item", children: /* @__PURE__ */ (0, import_jsx_runtime14.jsx)("div", { className: "rce-mtlink-title", children: props.text }) }),
    /* @__PURE__ */ (0, import_jsx_runtime14.jsx)("div", { className: "rce-mtlink-btn", children: (_a = props == null ? void 0 : props.actionButtons) == null ? void 0 : _a.map(
      (Item, index) => {
        var _a2;
        return /* @__PURE__ */ (0, import_jsx_runtime14.jsx)(
          "div",
          {
            className: "rce-mtlink-btn-content",
            onClick: () => {
              var _a3;
              return Item.onClickButton((_a3 = props == null ? void 0 : props.meetingID) != null ? _a3 : "");
            },
            onKeyDown: console.log,
            children: /* @__PURE__ */ (0, import_jsx_runtime14.jsx)(Item.Component, {})
          },
          (_a2 = props == null ? void 0 : props.meetingID) != null ? _a2 : index.toString()
        );
      }
    ) })
  ] }) });
};
var MeetingLink_default = MeetingLink;

// src/MessageBox/MessageBox.tsx
var import_ri = require("react-icons/ri");
var import_io2 = require("react-icons/io");
var import_md2 = require("react-icons/md");
var import_ti = require("react-icons/ti");
var import_date_fns2 = require("date-fns");
var import_classnames11 = __toESM(require("classnames"));

// src/SvgIcon/icons.tsx
var import_jsx_runtime15 = require("react/jsx-runtime");
var SVG = (_a) => {
  var _b = _a, {
    children
  } = _b, props = __objRest(_b, [
    "children"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime15.jsx)("svg", __spreadProps(__spreadValues({}, props), { children }));
};
var icons_default = SVG;

// src/SvgIcon/leftNotch.tsx
var import_classnames9 = __toESM(require("classnames"));
var import_jsx_runtime16 = require("react/jsx-runtime");
var LeftNotch = ({
  notchStyle = {},
  focus = false
}) => {
  return /* @__PURE__ */ (0, import_jsx_runtime16.jsx)(
    icons_default,
    {
      style: notchStyle,
      className: (0, import_classnames9.default)("rce-mbox-left-notch", {
        "message-focus": focus
      }),
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 20 20",
      children: /* @__PURE__ */ (0, import_jsx_runtime16.jsx)("path", { d: "M20 0v20L0 0", filter: "url(#filter1)" })
    }
  );
};

// src/SvgIcon/rightNotch.tsx
var import_classnames10 = __toESM(require("classnames"));
var import_jsx_runtime17 = require("react/jsx-runtime");
var RightNotch = ({
  notchStyle = {},
  focus = false
}) => {
  return /* @__PURE__ */ (0, import_jsx_runtime17.jsx)(
    icons_default,
    {
      style: notchStyle,
      className: (0, import_classnames10.default)("rce-mbox-right-notch", {
        "message-focus": focus
      }),
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 20 20",
      children: /* @__PURE__ */ (0, import_jsx_runtime17.jsx)("path", { d: "M0 0v20L20 0" })
    }
  );
};

// src/MessageBox/MessageBox.tsx
var import_jsx_runtime18 = require("react/jsx-runtime");
var MessageBox = (_a) => {
  var _b = _a, {
    focus = false,
    notch = true,
    styles,
    actionButtons
  } = _b, props = __objRest(_b, [
    "focus",
    "notch",
    "styles",
    "actionButtons"
  ]);
  const prevProps = (0, import_react5.useRef)(focus);
  const messageRef = (0, import_react5.useRef)(null);
  const positionCls = (0, import_classnames11.default)("rce-mbox", {
    "rce-mbox-right": props.position === "right"
  });
  const thatAbsoluteTime = !/(text|video|file|meeting|audio)/g.test(props.type || "text") && !(props.type === "location" && props.text);
  const dateText = props.date && (props.dateString || (0, import_date_fns2.format)(props.date, "HH:mm"));
  (0, import_react5.useEffect)(() => {
    var _a2;
    if (prevProps.current !== focus && focus) {
      if (messageRef == null ? void 0 : messageRef.current) {
        (_a2 = messageRef.current) == null ? void 0 : _a2.scrollIntoView({
          behavior: "smooth",
          block: "nearest",
          inline: "start"
        });
        if (props.onMessageFocused instanceof Function)
          props.onMessageFocused(true);
      }
    }
    prevProps.current = focus;
  }, [focus, props.onMessageFocused]);
  return /* @__PURE__ */ (0, import_jsx_runtime18.jsxs)(
    "div",
    {
      ref: messageRef,
      className: (0, import_classnames11.default)("rce-container-mbox", props.className),
      onClick: props.onClick,
      onKeyDown: console.log,
      children: [
        props.renderAddCmp instanceof Function ? props.renderAddCmp() : props.renderAddCmp,
        props.type === "system" ? /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(SystemMessage_default, __spreadProps(__spreadValues({}, props), { focus, notch })) : /* @__PURE__ */ (0, import_jsx_runtime18.jsxs)(
          "div",
          {
            style: styles,
            className: (0, import_classnames11.default)(
              positionCls,
              { "rce-mbox--clear-padding": thatAbsoluteTime },
              { "rce-mbox--clear-notch": !notch },
              { "message-focus": focus }
            ),
            children: [
              /* @__PURE__ */ (0, import_jsx_runtime18.jsxs)("div", { className: "rce-mbox-body", onContextMenu: props.onContextMenu, children: [
                !props.retracted && props.forwarded === true && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(
                  "div",
                  {
                    className: (0, import_classnames11.default)(
                      "rce-mbox-forward",
                      { "rce-mbox-forward-right": props.position === "left" },
                      { "rce-mbox-forward-left": props.position === "right" }
                    ),
                    onClick: props.onForwardClick,
                    onKeyDown: console.log,
                    children: /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(import_ri.RiShareForwardFill, {})
                  }
                ),
                !props.retracted && props.replyButton && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(
                  "div",
                  {
                    className: !props.forwarded ? (0, import_classnames11.default)(
                      "rce-mbox-forward",
                      { "rce-mbox-forward-right": props.position === "left" },
                      { "rce-mbox-forward-left": props.position === "right" }
                    ) : (0, import_classnames11.default)(
                      "rce-mbox-forward",
                      {
                        "rce-mbox-reply-btn-right": props.position === "left"
                      },
                      {
                        "rce-mbox-reply-btn-left": props.position === "right"
                      }
                    ),
                    onClick: props.onReplyClick,
                    onKeyDown: console.log,
                    children: /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(import_md2.MdMessage, {})
                  }
                ),
                !props.retracted && props.removeButton && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(
                  "div",
                  {
                    className: props.forwarded ? (0, import_classnames11.default)(
                      "rce-mbox-remove",
                      { "rce-mbox-remove-right": props.position === "left" },
                      { "rce-mbox-remove-left": props.position === "right" }
                    ) : (0, import_classnames11.default)(
                      "rce-mbox-forward",
                      {
                        "rce-mbox-reply-btn-right": props.position === "left"
                      },
                      {
                        "rce-mbox-reply-btn-left": props.position === "right"
                      }
                    ),
                    onClick: props.onRemoveMessageClick,
                    onKeyDown: console.log,
                    children: /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(import_md2.MdDelete, {})
                  }
                ),
                (props.title || props.avatar) && /* @__PURE__ */ (0, import_jsx_runtime18.jsxs)(
                  "div",
                  {
                    style: __spreadValues({}, props.titleColor && { color: props.titleColor }),
                    onClick: props.onTitleClick,
                    onKeyDown: console.log,
                    className: (0, import_classnames11.default)("rce-mbox-title", {
                      "rce-mbox-title--clear": props.type === "text"
                    }),
                    children: [
                      props.avatar && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(Avatar_default, { letterItem: props.letterItem, src: props.avatar }),
                      props.title && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)("span", { children: props.title })
                    ]
                  }
                ),
                props.forwardedMessageText ? /* @__PURE__ */ (0, import_jsx_runtime18.jsx)("div", { className: "rce-mbox-forwardedMessage", children: /* @__PURE__ */ (0, import_jsx_runtime18.jsxs)("div", { className: "rce-mbox-forwarded-message", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(import_ti.TiArrowForward, { fontSize: 18 }),
                  /* @__PURE__ */ (0, import_jsx_runtime18.jsxs)("i", { style: { margin: "0 3px 1px 0" }, children: [
                    " ",
                    props.forwardedMessageText
                  ] })
                ] }) }) : null,
                !props.forwardedMessageText && props.reply ? /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(ReplyMessage_default, __spreadValues({ onClick: props.onReplyMessageClick }, props)) : null,
                props.type === "text" && /* @__PURE__ */ (0, import_jsx_runtime18.jsxs)(
                  "div",
                  {
                    className: (0, import_classnames11.default)("rce-mbox-text", {
                      "rce-mbox-text-retracted": props.retracted,
                      left: props.position === "left",
                      right: props.position === "right"
                    }),
                    children: [
                      props.retracted && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(import_md2.MdBlock, {}),
                      props.text
                    ]
                  }
                ),
                props.type === "location" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(LocationMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "photo" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(PhotoMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "video" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(VideoMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "file" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(FileMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "spotify" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(SpotifyMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "meeting" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(MeetingMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "audio" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(AudioMessage_default, __spreadValues({ focus, notch }, props)),
                props.type === "meetingLink" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(MeetingLink_default, __spreadProps(__spreadValues({}, props), { actionButtons })),
                /* @__PURE__ */ (0, import_jsx_runtime18.jsxs)(
                  "div",
                  {
                    title: props.statusTitle,
                    className: (0, import_classnames11.default)(
                      "rce-mbox-time",
                      { "rce-mbox-time-block": thatAbsoluteTime },
                      { "non-copiable": !props.copiableDate }
                    ),
                    "data-text": props.copiableDate ? void 0 : dateText,
                    children: [
                      props.copiableDate && props.date && (props.dateString || (0, import_date_fns2.format)(props.date, "HH:mm")),
                      props.status && /* @__PURE__ */ (0, import_jsx_runtime18.jsxs)("span", { className: "rce-mbox-status", children: [
                        props.status === "waiting" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(import_md2.MdAccessTime, {}),
                        props.status === "sent" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(import_md2.MdCheck, {}),
                        props.status === "received" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(import_io2.IoIosDoneAll, {}),
                        props.status === "read" && /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(import_md2.MdDoneAll, { color: "#4FC3F7" })
                      ] })
                    ]
                  }
                )
              ] }),
              notch && (props.position === "right" ? /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(RightNotch, { notchStyle: props.notchStyle, focus }) : /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(LeftNotch, { notchStyle: props.notchStyle, focus }))
            ]
          }
        )
      ]
    }
  );
};
var MessageBox_default = MessageBox;

// src/ChatItem/ChatItem.tsx
var import_react6 = require("react");
var import_date_fns3 = require("date-fns");
var import_classnames12 = __toESM(require("classnames"));
var import_md3 = require("react-icons/md");
var import_fa5 = require("react-icons/fa");
var import_jsx_runtime19 = require("react/jsx-runtime");
var ChatItem = (_a) => {
  var _b = _a, {
    avatarFlexible = false,
    date = /* @__PURE__ */ new Date(),
    unread = 0,
    statusColorType = "badge",
    lazyLoadingImage = void 0,
    onAvatarError = () => void 0
  } = _b, props = __objRest(_b, [
    "avatarFlexible",
    "date",
    "unread",
    "statusColorType",
    "lazyLoadingImage",
    "onAvatarError"
  ]);
  const [onHoverTool, setOnHoverTool] = (0, import_react6.useState)(false);
  const [onDrag, setOnDrag] = (0, import_react6.useState)(false);
  (0, import_react6.useEffect)(() => {
    if (typeof props.setDragStates === "function") {
      props.setDragStates(!onDrag);
    }
  }, [props.setDragStates, onDrag]);
  const handleOnMouseEnter = () => setOnHoverTool(true);
  const handleOnMouseLeave = () => setOnHoverTool(false);
  const handleOnClick = (e) => {
    e.preventDefault();
    if (onHoverTool) return;
    if (typeof props.onClick === "function") {
      props.onClick(e);
    }
  };
  const onDragOver = (e, id) => {
    if (typeof props.onDragOver === "function") {
      props.onDragOver(e, id);
    }
  };
  const onDragEnter = (e, id) => {
    if (typeof props.onDragEnter === "function") {
      props.onDragEnter(e, id);
    }
    if (!onDrag) {
      setOnDrag(true);
    }
  };
  const onDragLeave = (e, id) => {
    if (typeof props.onDragLeave === "function") {
      props.onDragLeave(e, id);
    }
    if (onDrag) {
      setOnDrag(false);
    }
  };
  const onDrop = (e, id) => {
    if (typeof props.onDrop === "function") {
      props.onDrop(e, id);
    }
    if (onDrag) {
      setOnDrag(false);
    }
  };
  const onExpandItem = (e, id) => {
    e.preventDefault();
    e.stopPropagation();
    if (typeof props.onExpandItem === "function") {
      props.onExpandItem(e, id);
    }
  };
  return /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
    "div",
    {
      className: (0, import_classnames12.default)("rce-container-citem", props.className),
      onClick: handleOnClick,
      onKeyDown: console.log,
      onContextMenu: props.onContextMenu,
      children: /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)(
        "div",
        {
          className: "rce-citem",
          onDragOver: (e) => onDragOver(e, props.id),
          onDragEnter: (e) => onDragEnter(e, props.id),
          onDragLeave: (e) => onDragLeave(e, props.id),
          onDrop: (e) => onDrop(e, props.id),
          children: [
            props.onDragComponent && onDrag && props.onDragComponent,
            (onDrag && !props.onDragComponent || !onDrag) && /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)(import_jsx_runtime19.Fragment, { children: [
              /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)(
                "div",
                {
                  className: (0, import_classnames12.default)("rce-citem-avatar", {
                    "rce-citem-status-encircle": statusColorType === "encircle"
                  }),
                  children: [
                    /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
                      Avatar_default,
                      {
                        src: props.avatar,
                        alt: props.alt,
                        className: statusColorType === "encircle" ? "rce-citem-avatar-encircle-status" : "",
                        size: props.avatarSize || "large",
                        letterItem: props.letterItem,
                        sideElement: props.statusColor ? /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
                          "span",
                          {
                            className: "rce-citem-status",
                            style: statusColorType === "encircle" ? { border: `solid 2px ${props.statusColor}` } : { backgroundColor: props.statusColor },
                            children: props.statusText
                          }
                        ) : null,
                        onError: onAvatarError,
                        lazyLoadingImage,
                        type: (0, import_classnames12.default)("circle", { flexible: avatarFlexible })
                      }
                    ),
                    props.subList && props.subList.length > 0 && /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
                      "button",
                      {
                        type: "button",
                        className: "rce-citem-expand-button",
                        onClick: (e) => onExpandItem(e, props.id),
                        children: props.expanded ? /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(import_fa5.FaArrowUp, {}) : /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(import_fa5.FaArrowDown, {})
                      }
                    )
                  ]
                },
                "avatar"
              ),
              /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)("div", { className: "rce-citem-body", children: [
                /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)("div", { className: "rce-citem-body--top", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("div", { className: "rce-citem-body--top-title", children: props.title }),
                  /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("div", { className: "rce-citem-body--top-time", children: date && (props.dateString || (0, import_date_fns3.format)(date, "HH:mm")) })
                ] }),
                /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)("div", { className: "rce-citem-body--bottom", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("div", { className: "rce-citem-body--bottom-title", children: props.subtitle }),
                  /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)(
                    "div",
                    {
                      className: "rce-citem-body--bottom-tools",
                      onMouseEnter: handleOnMouseEnter,
                      onMouseLeave: handleOnMouseLeave,
                      children: [
                        props.showMute && /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)(
                          "div",
                          {
                            className: "rce-citem-body--bottom-tools-item",
                            onClick: props.onClickMute,
                            onKeyDown: console.log,
                            children: [
                              props.muted === true && /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(import_md3.MdVolumeOff, {}),
                              props.muted === false && /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(import_md3.MdVolumeUp, {})
                            ]
                          }
                        ),
                        props.showVideoCall && /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
                          "div",
                          {
                            className: "rce-citem-body--bottom-tools-item",
                            onClick: props.onClickVideoCall,
                            onKeyDown: console.log,
                            children: /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(import_md3.MdVideoCall, {})
                          }
                        )
                      ]
                    }
                  ),
                  /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("div", { className: "rce-citem-body--bottom-tools-item-hidden-hover", children: props.showMute && props.muted && /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("div", { className: "rce-citem-body--bottom-tools-item", children: /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(import_md3.MdVolumeOff, {}) }) }),
                  /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("div", { className: "rce-citem-body--bottom-status", children: unread > 0 ? /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("span", { children: unread }) : null }),
                  props.customStatusComponents ? props.customStatusComponents.map((item) => item) : null
                ] })
              ] }, "rce-citem-body")
            ] })
          ]
        }
      )
    },
    props.id
  );
};
var ChatItem_default = ChatItem;

// src/ChatList/ChatList.tsx
var import_classnames13 = __toESM(require("classnames"));
var import_jsx_runtime20 = require("react/jsx-runtime");
var import_react7 = require("react");
var list = [];
var ChatList = (props) => {
  const onClick = (item, index, event) => {
    if (props == null ? void 0 : props.onClick) {
      props == null ? void 0 : props.onClick(item, index, event);
    }
  };
  const onContextMenu = (item, index, event) => {
    if (props.onContextMenu instanceof Function)
      props.onContextMenu(item, index, event);
  };
  const onAvatarError = (item, index, event) => {
    if (props.onAvatarError instanceof Function)
      props.onAvatarError(item, index, event);
  };
  const setDragStates = (state) => {
    list.push(state);
  };
  const onDragLeaveMW = (e, id) => {
    var _a;
    if (list.length > 0)
      for (const item of list) {
        item instanceof Function && item(false);
      }
    (_a = props.onDragLeave) == null ? void 0 : _a.call(props, e, id.toString());
  };
  const onExpand = (item, index, event) => {
    if (props.onExpand instanceof Function) props.onExpand(item, index, event);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime20.jsx)("div", { className: (0, import_classnames13.default)("rce-container-clist", props.className), children: props.dataSource ? props.dataSource.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime20.jsxs)("div", { children: [
    /* @__PURE__ */ (0, import_jsx_runtime20.jsx)(
      ChatItem_default,
      __spreadProps(__spreadValues({}, x), {
        lazyLoadingImage: props == null ? void 0 : props.lazyLoadingImage,
        onAvatarError: (e) => onAvatarError(x, i, e),
        onContextMenu: (e) => onContextMenu(x, i, e),
        onClick: (e) => onClick(x, i, e),
        onClickMute: (e) => {
          var _a;
          return (_a = props.onClickMute) == null ? void 0 : _a.call(props, x, i, e);
        },
        onClickVideoCall: (e) => {
          var _a;
          return (_a = props.onClickVideoCall) == null ? void 0 : _a.call(props, x, i, e);
        },
        onDragOver: props == null ? void 0 : props.onDragOver,
        onDragEnter: props == null ? void 0 : props.onDragEnter,
        onDrop: props.onDrop,
        onDragLeave: (e) => onDragLeaveMW(e, i),
        onDragComponent: props.onDragComponent,
        setDragStates,
        onExpandItem: (e) => onExpand(x, i, e),
        expanded: x.expanded
      })
    ),
    x.subList && x.subList.length > 0 && /* @__PURE__ */ (0, import_jsx_runtime20.jsx)(import_jsx_runtime20.Fragment, { children: x.expanded && x.subList.map((sub, j) => /* @__PURE__ */ (0, import_react7.createElement)(
      ChatItem_default,
      __spreadProps(__spreadValues({}, sub), {
        className: "subitem",
        avatarSize: "xsmall",
        key: `${i}-${j.toString()}`,
        lazyLoadingImage: props == null ? void 0 : props.lazyLoadingImage,
        onAvatarError: (e) => onAvatarError(sub, j, e),
        onContextMenu: (e) => onContextMenu(sub, j, e),
        onClick: (e) => onClick(sub, j, e),
        onClickMute: (e) => {
          var _a;
          return (_a = props.onClickMute) == null ? void 0 : _a.call(props, sub, j, e);
        },
        onClickVideoCall: (e) => {
          var _a;
          return (_a = props.onClickVideoCall) == null ? void 0 : _a.call(props, sub, j, e);
        },
        onDragOver: props == null ? void 0 : props.onDragOver,
        onDragEnter: props == null ? void 0 : props.onDragEnter,
        onDrop: props.onDrop,
        onDragLeave: onDragLeaveMW,
        onDragComponent: props.onDragComponent,
        setDragStates
      })
    )) })
  ] }, i.toString())) : null });
};
var ChatList_default = ChatList;

// src/MessageList/MessageList.tsx
var import_react8 = require("react");
var import_classnames14 = __toESM(require("classnames"));
var import_fa6 = require("react-icons/fa");
var import_jsx_runtime21 = require("react/jsx-runtime");
var import_react9 = require("react");
var MessageList = (_a) => {
  var _b = _a, {
    reference,
    lockable = false,
    toBottomHeight = 300,
    downButton
  } = _b, props = __objRest(_b, [
    "reference",
    "lockable",
    "toBottomHeight",
    "downButton"
  ]);
  const [scrollBottom, setScrollBottom] = (0, import_react8.useState)(0);
  const [_downButton, setDownButton] = (0, import_react8.useState)(false);
  const prevProps = (0, import_react8.useRef)(props);
  const checkScroll = () => {
    const e = reference;
    if (!e || !e.current) return;
    if (toBottomHeight === "100%" || toBottomHeight && scrollBottom < Number(toBottomHeight)) {
      e.current.scrollTop = e.current.scrollHeight;
    } else {
      if (lockable) {
        e.current.scrollTop = e.current.scrollHeight - e.current.offsetHeight - scrollBottom;
      }
    }
  };
  (0, import_react8.useEffect)(() => {
    var _a2, _b2;
    if (!(reference == null ? void 0 : reference.current)) return;
    if (((_b2 = (_a2 = prevProps.current) == null ? void 0 : _a2.dataSource) == null ? void 0 : _b2.length) !== props.dataSource.length) {
      setScrollBottom(getBottom(reference.current));
      checkScroll();
    }
    prevProps.current = props;
  }, [checkScroll, reference, props]);
  const getBottom = (e) => {
    if (e) {
      return e.scrollHeight - e.scrollTop - e.offsetHeight;
    }
    return 0;
  };
  const onClick = (x, i, e) => {
    if (props.onClick instanceof Function) props.onClick(x, i, e);
  };
  const onOpen = (item, index, event) => {
    if (props.onOpen instanceof Function) props.onOpen(item, index, event);
  };
  const onDownload = (item, index, event) => {
    if (props.onDownload instanceof Function)
      props.onDownload(item, index, event);
  };
  const onPhotoError = (item, index, event) => {
    if (props.onPhotoError instanceof Function)
      props.onPhotoError(item, index, event);
  };
  const onTitleClick = (item, index, event) => {
    if (props.onTitleClick instanceof Function)
      props.onTitleClick(item, index, event);
  };
  const onForwardClick = (item, index, event) => {
    if (props.onForwardClick instanceof Function)
      props.onForwardClick(item, index, event);
  };
  const onReplyClick = (item, index, event) => {
    if (props.onReplyClick instanceof Function)
      props.onReplyClick(item, index, event);
  };
  const onReplyMessageClick = (item, index, event) => {
    if (props.onReplyMessageClick instanceof Function)
      props.onReplyMessageClick(item, index, event);
  };
  const onRemoveMessageClick = (item, index, event) => {
    if (props.onRemoveMessageClick instanceof Function)
      props.onRemoveMessageClick(item, index, event);
  };
  const onContextMenu = (item, index, event) => {
    if (props.onContextMenu instanceof Function)
      props.onContextMenu(item, index, event);
  };
  const onMessageFocused = (item, index, isFocused) => {
    if (props.onMessageFocused instanceof Function)
      props.onMessageFocused(item, index, isFocused);
  };
  const onMeetingMessageClick = (item, index, event) => {
    if (props.onMeetingMessageClick instanceof Function)
      props.onMeetingMessageClick(item, index, event);
  };
  const onScroll = (e) => {
    const element = e == null ? void 0 : e.currentTarget;
    const bottom = getBottom(element);
    setScrollBottom(bottom);
    if (toBottomHeight === "100%" || toBottomHeight && bottom > Number(toBottomHeight)) {
      if (!_downButton) {
        setDownButton(true);
        setScrollBottom(bottom);
      }
    } else {
      if (_downButton) {
        setDownButton(false);
        setScrollBottom(bottom);
      }
    }
    if (props.onScroll instanceof Function) {
      props.onScroll(e);
    }
  };
  const toBottom = (e) => {
    if (!(reference == null ? void 0 : reference.current)) return;
    const el = reference.current;
    el.scrollTop = el.scrollHeight;
    if (props.onDownButtonClick instanceof Function) props.onDownButtonClick(e);
  };
  const onMeetingMoreSelect = (item, i, e) => {
    if (props.onMeetingMoreSelect instanceof Function)
      props.onMeetingMoreSelect(item, i, e);
  };
  const onMeetingLinkClick = (item, i, e) => {
    if (props.onMeetingLinkClick instanceof Function)
      props.onMeetingLinkClick(item, i, e);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime21.jsxs)(
    "div",
    __spreadProps(__spreadValues({
      className: (0, import_classnames14.default)(["rce-container-mlist", props.className])
    }, props.customProps), {
      children: [
        !!props.children && props.isShowChild && props.children,
        /* @__PURE__ */ (0, import_jsx_runtime21.jsx)(
          "div",
          {
            ref: reference,
            onScroll: (e) => onScroll(e),
            className: "rce-mlist",
            children: props.dataSource ? props.dataSource.map((x, i) => /* @__PURE__ */ (0, import_react9.createElement)(
              MessageBox_default,
              __spreadProps(__spreadValues({}, x), {
                key: i.toString(),
                onOpen: (e) => onOpen(x, i, e),
                onPhotoError: (e) => onPhotoError(x, i, e),
                onDownload: (e) => onDownload(x, i, e),
                onTitleClick: props.onTitleClick && ((e) => onTitleClick(x, i, e)),
                onForwardClick: (e) => onForwardClick(x, i, e),
                onReplyClick: (e) => onReplyClick(x, i, e),
                onReplyMessageClick: (e) => onReplyMessageClick(x, i, e),
                onRemoveMessageClick: (e) => onRemoveMessageClick(x, i, e),
                onClick: (e) => onClick(x, i, e),
                onContextMenu: (e) => onContextMenu(x, i, e),
                onMeetingMoreSelect: (e) => onMeetingMoreSelect(x, i, e),
                onMessageFocused: (r) => onMessageFocused(x, i, r),
                onMeetingMessageClick: (e) => onMeetingMessageClick(x, i, e),
                onMeetingTitleClick: props.onMeetingTitleClick,
                onMeetingVideoLinkClick: props.onMeetingVideoLinkClick,
                onMeetingLinkClick: (e) => onMeetingLinkClick(x, i, e),
                actionButtons: props.actionButtons,
                styles: props.messageBoxStyles,
                notchStyle: props.notchStyle
              })
            )) : null
          }
        ),
        downButton === true && _downButton && toBottomHeight !== "100%" && /* @__PURE__ */ (0, import_jsx_runtime21.jsxs)(
          "div",
          {
            className: "rce-mlist-down-button",
            onClick: (e) => toBottom(e),
            onKeyDown: console.log,
            children: [
              /* @__PURE__ */ (0, import_jsx_runtime21.jsx)(import_fa6.FaChevronDown, {}),
              props.downButtonBadge !== void 0 ? /* @__PURE__ */ (0, import_jsx_runtime21.jsx)("span", { className: "rce-mlist-down-button--badge", children: props.downButtonBadge.toString() }) : null
            ]
          }
        )
      ]
    })
  );
};
var MessageList_default = MessageList;

// src/MeetingItem/MeetingItem.tsx
var import_md4 = require("react-icons/md");
var import_date_fns4 = require("date-fns");
var import_classnames15 = __toESM(require("classnames"));
var import_jsx_runtime22 = require("react/jsx-runtime");
var MeetingItem = (_a) => {
  var _b = _a, {
    subjectLimit = 60,
    onClick = () => void 0,
    avatarFlexible = false,
    date = /* @__PURE__ */ new Date(),
    lazyLoadingImage = void 0,
    avatarLimit = 5,
    avatars = [],
    audioMuted = true,
    onAvatarError = () => void 0,
    onMeetingClick = () => void 0,
    onShareClick = () => void 0
  } = _b, props = __objRest(_b, [
    "subjectLimit",
    "onClick",
    "avatarFlexible",
    "date",
    "lazyLoadingImage",
    "avatarLimit",
    "avatars",
    "audioMuted",
    "onAvatarError",
    "onMeetingClick",
    "onShareClick"
  ]);
  const statusColorType = props.statusColorType;
  const AVATAR_LIMIT = avatarLimit;
  const dateText = date && (props.dateString || (0, import_date_fns4.format)(date, "yyyy-MM-dd HH:mm:ss")) || (/* @__PURE__ */ new Date()).toISOString();
  const subject = props.subject && subjectLimit && props.subject.substring(0, subjectLimit) + (props.subject.length > subjectLimit ? "..." : "");
  return /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)(
    "div",
    {
      className: (0, import_classnames15.default)("rce-container-mtitem", props.className),
      onClick,
      onKeyDown: console.log,
      onContextMenu: props.onContextMenu,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("audio", { autoPlay: true, loop: true, muted: audioMuted, src: props.audioSource }),
        /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)("div", { className: "rce-mtitem", children: [
          /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)("div", { className: "rce-mtitem-top", children: [
            /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("div", { className: "rce-mtitem-subject", children: subject }),
            /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
              "div",
              {
                className: "rce-mtitem-share",
                onClick: onShareClick,
                onKeyDown: console.log,
                children: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(import_md4.MdLink, {})
              }
            )
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)("div", { className: "rce-mtitem-body", children: [
            /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)("div", { className: "rce-mtitem-body--avatars", children: [
              avatars == null ? void 0 : avatars.slice(0, AVATAR_LIMIT).map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                Avatar_default,
                {
                  src: x.src,
                  alt: x.alt,
                  className: x.statusColorType === "encircle" ? "rce-mtitem-avatar-encircle-status" : "",
                  size: "small",
                  letterItem: x.letterItem,
                  sideElement: x.statusColor ? /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                    "span",
                    {
                      className: "rce-mtitem-status",
                      style: statusColorType === "encircle" ? {
                        boxShadow: `inset 0 0 0 2px ${x.statusColor}, inset 0 0 0 5px #FFFFFF`
                      } : {
                        backgroundColor: x.statusColor
                      },
                      children: x.statusText
                    }
                  ) : /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(import_jsx_runtime22.Fragment, {}),
                  onError: onAvatarError,
                  lazyLoadingImage,
                  type: (0, import_classnames15.default)("circle", { flexible: avatarFlexible })
                },
                i.toString()
              )),
              avatars && AVATAR_LIMIT && avatars.length > AVATAR_LIMIT && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("div", { className: "rce-avatar-container circle small rce-mtitem-letter", children: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("span", { children: `+${avatars.length - AVATAR_LIMIT}` }) })
            ] }),
            /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)("div", { className: "rce-mtitem-body--functions", children: [
              props.closable && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                "div",
                {
                  className: "rce-mtitem-closable",
                  onClick: props.onCloseClick,
                  onKeyDown: console.log,
                  children: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(import_md4.MdCall, {})
                }
              ),
              /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                "div",
                {
                  className: "rce-mtitem-button",
                  onClick: onMeetingClick,
                  onKeyDown: console.log,
                  children: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(import_md4.MdVideoCall, {})
                }
              )
            ] })
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("div", { className: "rce-mtitem-footer", children: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("span", { className: "rce-mtitem-date", children: dateText }) })
        ] })
      ]
    }
  );
};
var MeetingItem_default = MeetingItem;

// src/MeetingList/MeetingList.tsx
var import_classnames16 = __toESM(require("classnames"));
var import_jsx_runtime23 = require("react/jsx-runtime");
var import_react10 = require("react");
var MeetingList = (props) => {
  var _a;
  const onClick = (item, index, event) => {
    if (props.onClick instanceof Function) props.onClick(item, index, event);
  };
  const onContextMenu = (item, index, event) => {
    event.preventDefault();
    if (props.onContextMenu instanceof Function)
      props.onContextMenu(item, index, event);
  };
  const onAvatarError = (item, index, event) => {
    if (props.onAvatarError instanceof Function)
      props.onAvatarError(item, index, event);
  };
  const onMeetingClick = (item, index, event) => {
    if (props.onMeetingClick instanceof Function)
      props.onMeetingClick(item, index, event);
  };
  const onShareClick = (item, index, event) => {
    if (props.onShareClick instanceof Function)
      props.onShareClick(item, index, event);
  };
  const onCloseClick = (item, index, event) => {
    if (props.onCloseClick instanceof Function)
      props.onCloseClick(item, index, event);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime23.jsx)(
    "div",
    {
      ref: props.cmpRef,
      className: (0, import_classnames16.default)("rce-container-mtlist", props.className),
      children: (_a = props.dataSource) == null ? void 0 : _a.map((x, i) => /* @__PURE__ */ (0, import_react10.createElement)(
        MeetingItem_default,
        __spreadProps(__spreadValues({}, x), {
          key: i,
          lazyLoadingImage: props.lazyLoadingImage,
          onAvatarError: (e) => onAvatarError(x, i, e),
          onContextMenu: (e) => onContextMenu(x, i, e),
          onClick: (e) => onClick(x, i, e),
          onMeetingClick: (e) => onMeetingClick(x, i, e),
          onShareClick: (e) => onShareClick(x, i, e),
          onCloseClick: (e) => onCloseClick(x, i, e)
        })
      ))
    }
  );
};
var MeetingList_default = MeetingList;

// src/Input/Input.tsx
var import_react11 = require("react");
var import_classnames17 = __toESM(require("classnames"));
var import_jsx_runtime24 = require("react/jsx-runtime");
var Input = (_a) => {
  var _b = _a, {
    type = "text",
    multiline = false,
    minHeight = 25,
    maxHeight = 200,
    autoHeight = true,
    autofocus = false
  } = _b, props = __objRest(_b, [
    "type",
    "multiline",
    "minHeight",
    "maxHeight",
    "autoHeight",
    "autofocus"
  ]);
  var _a2, _b2, _c;
  (0, import_react11.useEffect)(() => {
    var _a3, _b3;
    if (autofocus) (_b3 = (_a3 = props.reference) == null ? void 0 : _a3.current) == null ? void 0 : _b3.focus();
    if (props.clear instanceof Function) {
      props.clear(clear);
    }
  }, [autofocus, props.clear, (_b2 = (_a2 = props.reference) == null ? void 0 : _a2.current) == null ? void 0 : _b2.focus]);
  const onChangeEvent = ({
    ev,
    target
  }) => {
    const el = target;
    if (multiline) {
      if (autoHeight) {
        if (el.style.height !== `${minHeight}px`) {
          el.style.height = `${minHeight}px`;
        }
        let height = "";
        if (el.scrollHeight <= maxHeight) height = `${el.scrollHeight}px`;
        else height = `${maxHeight}px`;
        if (el.style.height !== height) {
          el.style.height = height;
        }
      }
    }
    if (props.maxlength && (el.value || "").length > props.maxlength) {
      if (props.onMaxLengthExceed instanceof Function)
        props.onMaxLengthExceed();
      if (props.reference) {
        props.reference.current.value = (el.value || "").substring(
          0,
          props.maxlength
        );
      }
      return;
    }
    if (ev && props.onChange instanceof Function) props.onChange({ ev });
  };
  const clear = () => {
    var _a3, _b3, _c2;
    const current = {
      FAKE_EVENT: true,
      target: (_a3 = props.reference) == null ? void 0 : _a3.current
    };
    if ((_c2 = (_b3 = props.reference) == null ? void 0 : _b3.current) == null ? void 0 : _c2.value) {
      props.reference.current.value = "";
    }
    onChangeEvent(current);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime24.jsxs)("div", { className: (0, import_classnames17.default)("rce-container-input", props.className), children: [
    props.leftButtons && /* @__PURE__ */ (0, import_jsx_runtime24.jsx)("div", { className: "rce-input-buttons", children: props.leftButtons }),
    !multiline ? /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
      "input",
      {
        ref: props.reference,
        type,
        className: (0, import_classnames17.default)("rce-input"),
        placeholder: props.placeholder,
        defaultValue: props.defaultValue,
        style: props.inputStyle,
        onChange: (e) => {
          var _a3;
          return onChangeEvent({ ev: e, target: (_a3 = props.reference) == null ? void 0 : _a3.current });
        },
        onCopy: props.onCopy,
        onCut: props.onCut,
        onPaste: props.onPaste,
        onBlur: props.onBlur,
        onFocus: props.onFocus,
        onSelect: props.onSelect,
        onSubmit: props.onSubmit,
        onReset: props.onReset,
        onKeyDown: props.onKeyDown,
        onKeyPress: props.onKeyPress,
        onKeyUp: props.onKeyUp,
        value: props.value
      }
    ) : /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
      "textarea",
      {
        ref: props.reference,
        className: (0, import_classnames17.default)("rce-input", "rce-input-textarea"),
        placeholder: props.placeholder,
        defaultValue: props.defaultValue,
        style: props.inputStyle,
        onChange: (e) => {
          var _a3;
          return onChangeEvent({ ev: e, target: (_a3 = props.reference) == null ? void 0 : _a3.current });
        },
        onCopy: props.onCopy,
        onCut: props.onCut,
        onPaste: props.onPaste,
        onBlur: props.onBlur,
        onFocus: props.onFocus,
        onSelect: props.onSelect,
        onSubmit: props.onSubmit,
        onReset: props.onReset,
        onKeyDown: props.onKeyDown,
        onKeyPress: props.onKeyPress,
        onKeyUp: props.onKeyUp,
        children: props.defaultValue ? (_c = props == null ? void 0 : props.value) != null ? _c : null : null
      }
    ),
    props.rightButtons && /* @__PURE__ */ (0, import_jsx_runtime24.jsx)("div", { className: "rce-input-buttons", children: props.rightButtons })
  ] });
};
var Input_default = Input;

// src/Navbar/Navbar.tsx
var import_classnames18 = __toESM(require("classnames"));
var import_jsx_runtime25 = require("react/jsx-runtime");
var Navbar = (_a) => {
  var _b = _a, { type = "light" } = _b, props = __objRest(_b, ["type"]);
  return /* @__PURE__ */ (0, import_jsx_runtime25.jsxs)("div", { className: (0, import_classnames18.default)("rce-navbar", type, props.className), children: [
    /* @__PURE__ */ (0, import_jsx_runtime25.jsx)("div", { className: "rce-navbar-item rce-navbar-item__left", children: props.left }),
    /* @__PURE__ */ (0, import_jsx_runtime25.jsx)("div", { className: "rce-navbar-item rce-navbar-item__center", children: props.center }),
    /* @__PURE__ */ (0, import_jsx_runtime25.jsx)("div", { className: "rce-navbar-item rce-navbar-item__right", children: props.right })
  ] });
};
var Navbar_default = Navbar;

// src/SideBar/SideBar.tsx
var import_classnames19 = __toESM(require("classnames"));
var import_jsx_runtime26 = require("react/jsx-runtime");
var SideBar = (_a) => {
  var _b = _a, { type = "dark" } = _b, props = __objRest(_b, ["type"]);
  var _a2, _b2, _c, _d;
  return /* @__PURE__ */ (0, import_jsx_runtime26.jsxs)("div", { className: (0, import_classnames19.default)("rce-sbar", type, (_a2 = props.data) == null ? void 0 : _a2.className), children: [
    /* @__PURE__ */ (0, import_jsx_runtime26.jsx)("div", { className: "rce-sbar-item", children: (_b2 = props.data) == null ? void 0 : _b2.top }),
    /* @__PURE__ */ (0, import_jsx_runtime26.jsx)("div", { className: "rce-sbar-item rce-sbar-item__center", children: (_c = props.data) == null ? void 0 : _c.center }),
    /* @__PURE__ */ (0, import_jsx_runtime26.jsx)("div", { className: "rce-sbar-item", children: (_d = props.data) == null ? void 0 : _d.bottom })
  ] });
};
var SideBar_default = SideBar;

// src/Popup/Popup.tsx
var import_classnames20 = __toESM(require("classnames"));
var import_jsx_runtime27 = require("react/jsx-runtime");
var Popup = (_a) => {
  var props = __objRest(_a, []);
  var _a2, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o;
  if (((_a2 = props.popup) == null ? void 0 : _a2.show) === true)
    return /* @__PURE__ */ (0, import_jsx_runtime27.jsx)(
      "div",
      {
        className: (0, import_classnames20.default)("rce-popup-wrapper", props.type, props.className),
        children: /* @__PURE__ */ (0, import_jsx_runtime27.jsxs)("div", { className: "rce-popup", children: [
          ((_b = props.popup) == null ? void 0 : _b.renderHeader) ? /* @__PURE__ */ (0, import_jsx_runtime27.jsx)("div", { className: "rce-popup-header", children: (_c = props.popup) == null ? void 0 : _c.renderHeader() }) : /* @__PURE__ */ (0, import_jsx_runtime27.jsxs)("div", { className: "rce-popup-header", children: [
            /* @__PURE__ */ (0, import_jsx_runtime27.jsx)("span", { children: (_d = props.popup) == null ? void 0 : _d.header }),
            ((_e = props.popup) == null ? void 0 : _e.header) && ((_g = (_f = props.popup) == null ? void 0 : _f.headerButtons) == null ? void 0 : _g.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime27.jsx)(Button_default, __spreadValues({}, x), i.toString())))
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime27.jsx)(
            "div",
            {
              className: "rce-popup-content",
              style: { color: (_h = props.popup) == null ? void 0 : _h.color },
              children: ((_i = props.popup) == null ? void 0 : _i.renderContent) ? (_j = props.popup) == null ? void 0 : _j.renderContent() : (_k = props.popup) == null ? void 0 : _k.text
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime27.jsx)("div", { className: "rce-popup-footer", children: ((_l = props.popup) == null ? void 0 : _l.renderFooter) ? (_m = props.popup) == null ? void 0 : _m.renderFooter() : (_o = (_n = props.popup) == null ? void 0 : _n.footerButtons) == null ? void 0 : _o.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime27.jsx)(Button_default, __spreadValues({}, x), i.toString())) })
        ] })
      }
    );
  return null;
};
var Popup_default = Popup;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AudioMessage,
  Avatar,
  Button,
  ChatItem,
  ChatList,
  Circle,
  Dropdown,
  FileMessage,
  Input,
  LocationMessage,
  MeetingItem,
  MeetingLink,
  MeetingList,
  MeetingMessage,
  MessageBox,
  MessageList,
  Navbar,
  PhotoMessage,
  Popup,
  ReplyMessage,
  SideBar,
  SpotifyMessage,
  SystemMessage,
  VideoMessage
});
